<?php

class wps_autooptimize {

  /**
   * Our main class constructor
   */
  public function __construct() {
    global $wps_ao;

    // What is unlocked?
    $settings = get_option(WPS_IC_SETTINGS);
    if ( ! empty($settings)) {
      if (! empty($settings['autopilot']) && $settings['otto'] == 'on-upload') {

        $test = get_option('wps_ic_test');
        if ($test || !empty($test)) {
          return;
        } else {
          add_filter('add_attachment', array($this, 'on_upload'), 10, 2);
        }
      }
    }
  }


  public function on_upload($post_ID) {
    global $wps_ic;
    $optimize_on_upload = true;
    $attachment_ID = $post_ID;

    $file_data = get_attached_file($attachment_ID);
    $type      = wp_check_filetype($file_data);

    $allowed_types         = array();
    $allowed_types['jpg']  = 'jpg';
    $allowed_types['jpeg'] = 'jpeg';
    $allowed_types['gif']  = 'gif';
    $allowed_types['png']  = 'png';

    if (in_array(strtolower($type['ext']), $allowed_types)) {

      // Check credits
      $check_credits = wp_remote_get($wps_ic::$ic_api_url . '/?apikey=' . $wps_ic::$api_key . '&check_credits=true', array('timeout' => '25', 'sslverify' => false));

      // Total to compress
      $required_credits = 1 ;

      if (wp_remote_retrieve_response_code($check_credits) == 200) {
        $body = wp_remote_retrieve_body($check_credits);
        $body = json_decode($body, true);

        if ($body['success'] == 'true') {
          // OK
          $credits = $body['data']['credits'];

          if ($credits == 0) {
            return;
          }

          // User does not have enough credits
          if ($required_credits > $credits) {
            return;
          }

        }
      }

      $excluded = get_post_meta($attachment_ID, 'wps_ic_exclude', true);
      if ( ! empty($excluded) && $excluded == 'true') {
        return;
      }

      $data = get_post_meta($attachment_ID, 'wps_ic_data', true);
      if ( ! empty($data) && ! empty($data['new'])) {
        return;
      }

      // Allowed type
      $file_data = get_attached_file($attachment_ID);
      $type      = wp_check_filetype($file_data);

      // Add generate thumbnail to queue
      $attach_data = wp_generate_attachment_metadata($attachment_ID, $file_data);
      wp_update_attachment_metadata($attachment_ID, $attach_data);

      // Mark attachment as compressing
      update_post_meta($attachment_ID, 'wps_ic_in_bulk', 'true');
      $wps_ic->queue->remove_queue($attachment_ID);
      $wps_ic->compress->bulk(array('attachments' => array($attachment_ID)));

      // Testing
      #wp_schedule_single_event(time(), 'wps_ic_upload_image', array($attachment_ID));

    }
  }


}