var ic_hash = Math.random().toString(36).substr(2, 5);
//
var timeout_ajax = 30 * 1000;
var bulk_retry = 0;
var bulk_count = 0;
var wps_restore = '';
var wps_compress = '';
var wps_bulk_running = false;
//
var wps_compress_objects = [];
var wps_restore_objects = [];
var saving_settings = false;

jQuery(document).ready(function ($) {


    /**
     * Reset Stats
     */
    $('.ic-reset-stats').on('click', function (e) {
        e.preventDefault();
        show_stats_reset_popup();
        return false;
    });


    /**
     * Reset Cache
     */
    $('.ic-reset-cache').on('click', function (e) {
        e.preventDefault();
        show_cdn_reset_popup();
        return false;
    });


    /**
     * Checkbox Change Ajax
     */
    $('.wp-ic-ajax-checkbox').on('click', function (e) {
        e.preventDefault();

        saving_settings = true;

        var parent = $(this).parent();
        var input = $('input', parent);
        var setting = $(input).data('setting_name');
        var value = $(input).data('setting_value');
        var checked = $(input).is(':checked');
        value = $(input).data('setting_value');

        if ($(input).is(':checked')) {
            $(input).removeAttr('checked');
            checked = false;
        } else {
            $(input).attr('checked', 'checked');
            checked = true;
        }

        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: setting, value: value, checked: checked, checkbox: true}, function (response) {
            if (response.success) {
                // Nothing
                saving_settings = false;
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });
    });


    /**
     * Tooltip
     */
    $('.wps-ic-action-button').live({
        mouseenter: function () {
            var button = $(this);
            var text = $(button).attr('title');

            $(button).append('<div class="wps-ic-action-tooltip"><p>' + text + '</p></div>');

            var element = $('.wps-ic-action-tooltip', button);
            var width = $(element).width();
            $(element).css('left', '-' + ((width / 2) - 20) + 'px');


        },
        mouseleave: function () {
            var button = $(this);
            var text = $(button).attr('title');

            $('.wps-ic-action-tooltip', button).remove();
        }
    });


    /**
     * View Test Results
     */
    $('.wps-ic-view-results').live('click', function (e) {
        e.preventDefault();

        var btn = $(this);

        if ($('.wps-ic-test-results').is(':visible')) {
            $(btn).html('View Results');
            $('.wps-ic-test-results').fadeOut();
        } else {
            $(btn).html('Hide Results');
            $('.wps-ic-test-results').fadeIn();
        }


    });


    /**
     * Run Tests
     */
    $('.wps-ic-run-tests').live('click', function (e) {
        e.preventDefault();

        var btn = $(this);

        $(btn).hide();
        $('.wps-ic-test-results').hide();
        $('.wps-ic-spinner-tests').show();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'ic_run_tests'}, function (response) {
            $('.wps-ic-spinner-tests').hide();
            $(btn).show();
            $('.wps-ic-test-results').html(response.data).show();
        });
    });


    /**
     * Action Disabled
     */
    $('.wps-ic-compress-queue-clear').live('click', function (e) {
        e.preventDefault();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_clear_queue'}, function (response) {

        });
    });


    /**
     * Action Disabled
     */
    $('.wps-ic-action-disabled').live('click', function (e) {
        e.preventDefault();
        alert('This action has been disabled!');
    });


    /**
     * Remote Restore Image Button - Single!!
     */
    $('.wps-ic-remote-restore').live('click', function (e) {
        e.preventDefault();

        wps_restore = 'true';
        trigger_speed = 1500;

        var button = $(this);
        var attachment_id = $(this).data('image_id');
        var select = $('input[name="wps_ic_restore_' + attachment_id + '"]').val();

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        wps_restore_objects.push(attachment_id);

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore', attachment_id: attachment_id, file: select, attachments: wps_restore_objects, hash: ic_hash}, function (response) {

            wps_ic_remote_restore_heartbeat();
            if (response.success == true) {
                trigger_speed = 5000;
                wps_compress = '';
            }

        });

    });


    /**
     * Reset Image Button - Single!!
     */
    $('.wps-ic-reset-single').live('click', function (e) {
        e.preventDefault();

        wps_restore = 'true';
        trigger_speed = 1500;

        var button = $(this);
        var attachment_id = $(this).data('image_id');
        var select = $('input[name="wps_ic_restore_' + attachment_id + '"]').val();

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        wps_restore_objects.push(attachment_id);

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore', attachment_id: attachment_id, type: 'reset', attachments: wps_restore_objects, hash: ic_hash}, function (response) {

            wps_ic_bulk_heartbeat();
            if (response.success == true) {
                trigger_speed = 5000;
                wps_compress = '';
            }

        });

    });


    /**
     * Restore Image Button - Bulk!!
     */
    var bulk_stop = false;
    var bulk_restoring = false;
    var compressing = false;
    $('.wps-ic-restore-bulk').on('click', function (e) {

        var button = $(this);
        var results_container = $('.wps-ic-bulk-progress-container');
        var title = $('.wps-ic-media-bulk');

        $(results_container).fadeIn();

        bulk_stop = false;
        bulk_restoring = true;

        //wps_bulk_messages();

        var message_list = $('ul li', '.wps-ic-bulk-prep');

        $('h1.wps-ic-restore-not-started', title).hide();
        $('h1.wps-ic-restore-started', title).show();

        $(button).hide();
        $('a.wps-ic-bulk-restore-stop').show();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_bulk_prep_background', hash: ic_hash}, function (response) {
            if (response.success) {

                var bulk_data = response.data;
                wps_ic_background_restore();


            } else {
                alert('Ooops! This is embarrassing... :(');
            }
        });


    });


    /**
     * Restore Images in Background
     */
    $('.wps-ic-restore-bulk-hidden').on('click', function (e) {

        $.post(ajaxurl, {action: 'wps_ic_notify', checked: false}, function (response) {
            if (response.success) {
                // Nothing
            }
        });

        swal({
            title: '',
            html: jQuery('#ic_confirm_restore').html(),
            width: 900,
            showCancelButton: true,
            confirmButtonColor: '#08a8fc',
            confirmButtonText: 'Restore all images',
            cancelButtonText: "No, not now",
            onOpen: function () {
                $('.wp-ic-ajax-checkbox-v2').live('click', function (e) {
                    e.preventDefault();

                    var parent = $(this).parent().parent();
                    var input = $('input', parent);
                    var setting = $(input).data('setting_name');
                    var value = $(input).data('setting_value');
                    var checked = $(input).is(':checked');
                    value = $(input).data('setting_value');

                    if ($(input).is(':checked')) {
                        $(input).removeAttr('checked');
                        checked = false;
                    } else {
                        $(input).attr('checked', 'checked');
                        checked = true;
                    }

                    $.post(ajaxurl, {action: 'wps_ic_notify', checked: checked}, function (response) {
                        if (response.success) {
                            // Nothing
                        }
                    });
                });
            }
        }).then(function (isConfirm) {
            if (isConfirm) {
                swal({
                    title: '',
                    html: jQuery('#ic_hidden_loading').html(),
                    width: 900,
                    showCloseButton: false,
                    showCancelButton: false,
                    showConfirmButton: false,
                    allowOutsideClick: false,
                    onOpen: function () {

                        $.ajaxSetup({async: true, cache: false});
                        $.post(ajaxurl, {action: 'wps_ic_restore_bulk_prep_background_hidden', hash: ic_hash}, function (response) {
                            if (response.success) {

                                $.post(ajaxurl, {action: 'wps_ic_restore_hidden_bulk', hash: ic_hash}, function (response) {
                                    swal({
                                        title: '',
                                        html: jQuery('#ic_hidden_restore_started').html(),
                                        timer: 3000,
                                        width: 900,
                                        showCloseButton: true,
                                        showCancelButton: false,
                                        showConfirmButton: false,
                                        onClose: function () {
                                            window.location.reload();
                                        }
                                    });
                                });

                                //wps_transient_queue();

                            } else {
                                alert('Ooops! This is embarrassing... :(');
                            }
                        });

                    }
                });
            }
        });


    });


    /**
     * Restore Images in Background
     */
    $('.wps-ic-restore-bulk-background').on('click', function (e) {

        var button = $(this);
        var results_container = $('.wps-ic-bulk-progress-container');
        var title = $('.wps-ic-media-bulk');

        $(results_container).fadeIn();

        bulk_stop = false;
        bulk_restoring = true;

        //wps_bulk_messages();

        var message_list = $('ul li', '.wps-ic-bulk-prep');

        $('h1.wps-ic-restore-not-started', title).hide();
        $('h1.wps-ic-restore-started', title).show();

        $(button).hide();
        $('a.wps-ic-bulk-restore-stop').show();

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_bulk_prep_background_hidden', hash: ic_hash}, function (response) {
            if (response.success) {

                $.post(ajaxurl, {action: 'wps_ic_restore_hidden_bulk', hash: ic_hash}, function (response) {
                    swal({
                        title: '',
                        html: jQuery('#ic_hidden_restore_started').html(),
                        width: 900,
                        timer: 3000,
                        showCloseButton: true,
                        showCancelButton: false,
                        showConfirmButton: false,
                        onClose: function () {
                            window.location.reload();
                        }
                    });
                });


            } else {
                alert('Ooops! This is embarrassing... :(');
            }
        });


    });


    $('.wps-ic-regen-thumbnails').on('click', function (e) {


        swal({
            title: '',
            html: jQuery('#ic_confirm_regen').html(),
            width: 900,
            showCancelButton: true,
            confirmButtonColor: '#08a8fc',
            confirmButtonText: 'Regenerate all images',
            cancelButtonText: "No, not now",
            onOpen: function () {

                $('.wp-ic-ajax-checkbox-v2').live('click', function (e) {
                    e.preventDefault();

                    var parent = $(this).parent().parent();
                    var input = $('input', parent);
                    var setting = $(input).data('setting_name');
                    var value = $(input).data('setting_value');
                    var checked = $(input).is(':checked');
                    value = $(input).data('setting_value');

                    if ($(input).is(':checked')) {
                        $(input).removeAttr('checked');
                        checked = false;
                    } else {
                        $(input).attr('checked', 'checked');
                        checked = true;
                    }
                });
            }
        }).then(function (isConfirm) {
            if (isConfirm) {
                swal({
                    title: '',
                    html: jQuery('#ic_hidden_loading').html(),
                    width: 900,
                    showCloseButton: false,
                    showCancelButton: false,
                    showConfirmButton: false,
                    allowOutsideClick: false,
                    onOpen: function () {

                        $.ajaxSetup({async: true, cache: false});
                        $.post(ajaxurl, {action: 'wps_ic_regenerate_thumbnails_prep', hash: ic_hash}, function (response) {
                            if (response.success) {

                                var bulk_data = response.data.queue;
                                $.post(ajaxurl, {action: 'wps_ic_regenerate_thumbnails_bulk', hash: ic_hash}, function (response) {

                                    if (response.success) {
                                        swal({
                                            title: '',
                                            html: jQuery('#ic_hidden_regen_started').html(),
                                            width: 900,
                                            showCloseButton: true,
                                            showCancelButton: false,
                                            showConfirmButton: false,
                                            timer: 3000,
                                            onClose: function () {
                                                window.location.reload();
                                            }
                                        });
                                    }

                                });


                            } else {
                                alert('Ooops! This is embarrassing... :(');
                            }
                        });

                    }
                });
            }
        });


    });


    /**
     * Compress Image Button - Bulk!!
     */
    $('.wps-ic-compress-bulk-hidden').on('click', function (e) {

        var debug = false;
        if ($(this).hasClass('ic-debug')) {
            debug = true;
        }

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_check_compress_count'}, function (response) {
            if (response.success) {


                swal({
                    title: '',
                    html: jQuery('#ic_credits_loading').html(),
                    width: 900,
                    showCloseButton: false,
                    showCancelButton: false,
                    showConfirmButton: false,
                    allowOutsideClick: false,
                    onOpen: function () {
                        $.ajaxSetup({async: true, cache: false});
                        $.post(ajaxurl, {action: 'wps_ic_api_check_credits'}, function (response) {
                            if (response.success) {
                                if (response.data <= 0) {
                                    swal.close();

                                    swal({
                                        title: '',
                                        html: jQuery('#ic_no_credits_popup').html(),
                                        width: 900,
                                        showCloseButton: true,
                                        showCancelButton: false,
                                        showConfirmButton: false,
                                        allowOutsideClick: true
                                    });
                                } else {


                                    swal({
                                        title: '',
                                        html: jQuery('#ic_confirm_optimize').html(),
                                        width: 900,
                                        showCancelButton: true,
                                        confirmButtonColor: '#08a8fc',
                                        confirmButtonText: 'Optimize all images',
                                        cancelButtonText: "No, not now",
                                        onOpen: function () {

                                            $('.wp-ic-ajax-checkbox-v2').live('click', function (e) {
                                                e.preventDefault();

                                                var parent = $(this).parent().parent();
                                                var input = $('input', parent);
                                                var setting = $(input).data('setting_name');
                                                var value = $(input).data('setting_value');
                                                var checked = $(input).is(':checked');
                                                value = $(input).data('setting_value');

                                                if ($(input).is(':checked')) {
                                                    $(input).removeAttr('checked');
                                                    checked = false;
                                                } else {
                                                    $(input).attr('checked', 'checked');
                                                    checked = true;
                                                }
                                            });
                                        }
                                    }).then(function (isConfirm) {
                                        if (isConfirm) {
                                            swal({
                                                title: '',
                                                html: jQuery('#ic_hidden_loading').html(),
                                                width: 900,
                                                showCloseButton: false,
                                                showCancelButton: false,
                                                showConfirmButton: false,
                                                allowOutsideClick: false,
                                                onOpen: function () {

                                                    $.ajaxSetup({async: true, cache: false});
                                                    $.post(ajaxurl, {action: 'wps_ic_compress_bulk_prep_hidden_background', hash: ic_hash, debug: debug}, function (response) {
                                                        if (response.success) {

                                                            var bulk_data = response.data.queue;
                                                            //wps_ic_background_hidden_compress();

                                                            $.post(ajaxurl, {action: 'wps_ic_compress_hidden_bulk', hash: ic_hash, debug: debug}, function (response) {

                                                                if (response.success) {
                                                                    swal({
                                                                        title: '',
                                                                        html: jQuery('#ic_hidden_compress_started').html(),
                                                                        width: 900,
                                                                        showCloseButton: true,
                                                                        showCancelButton: false,
                                                                        showConfirmButton: false,
                                                                        timer: 3000,
                                                                        onClose: function () {
                                                                            window.location.reload();
                                                                        }
                                                                    });
                                                                }

                                                                //wps_transient_queue();

                                                            });


                                                        } else {
                                                            if (response.data == 'api_offline') {
                                                                swal({
                                                                    title: '',
                                                                    html: jQuery('#ic_offline_popup').html(),
                                                                    width: 900,
                                                                    showCloseButton: true,
                                                                    showCancelButton: false,
                                                                    showConfirmButton: false,
                                                                    onClose: function () {
                                                                        window.location.reload();
                                                                    }
                                                                });
                                                            } else if (response.data == 'not_enough_credits' || response.data == 'no_credits') {
                                                                swal({
                                                                    title: '',
                                                                    html: jQuery('#ic_no_credits_popup_bulk').html(),
                                                                    width: 900,
                                                                    showCloseButton: true,
                                                                    showCancelButton: false,
                                                                    showConfirmButton: false,
                                                                    onClose: function () {
                                                                        window.location.reload();
                                                                    }
                                                                });
                                                            } else {
                                                                alert('Ooops! This is embarrassing... :(');
                                                            }
                                                        }
                                                    });

                                                }
                                            });
                                        }
                                    });

                                }
                            }
                        });

                    }
                });

            } else {
                swal({
                    title: '',
                    html: jQuery('#ic_all_compressed').html(),
                    width: 900,
                    showCloseButton: false,
                    showCancelButton: false,
                    showConfirmButton: false,
                    allowOutsideClick: true,
                });
            }
        });

    });


    /**
     * Compress Bulk - Stop
     */
    $('.wps-ic-bulk-stop').live('click', function (e) {
        e.preventDefault();

        var button = $(this);
        var action = $(this).data('action');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        $(button).html('Stopping... Waiting until last image is done.');

        $('h1.wps-ic-compress-not-started', title).show();
        $('h1.wps-ic-compress-started', title).hide();

        bulk_stop = true;
        bulk_restoring = false;


        return false;
    });


    /**
     * Restore Bulk - Stop
     */
    $('.wps-ic-bulk-restore-stop').live('click', function (e) {
        e.preventDefault();

        var button = $(this);
        var action = $(this).data('action');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        $(button).html('Stopping... Waiting until last image is done.');

        $('h1.wps-ic-compress-not-started', title).show();
        $('h1.wps-ic-compress-started', title).hide();

        bulk_stop = true;

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_bulk_stop'}, function (response) {
            if (response.success) {
                compressing = false;
                clearInterval(messageInterval);
                $('div', results_container).hide();
                $(results_container).append(response.data);
                //$(info).html(response.data);
                //$(button).html('Continue').removeClass('wps-ic-bulk-stop');
                $(button).hide();
                $('button.wps-ic-compress-bulk').show();
                window.location.reload();
            } else {
                alert('Ooops! This is embarrassing... :(');
            }
        });

        return false;
    });


    $('.wps-ic-pro-exclude,.wps-ic-pro-include').live('click', function (e) {
        e.preventDefault();

        var button = $(this);
        var attachment_id = $(button).data('attachment_id');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();


        $.ajax({
            url: ajaxurl,
            type: 'POST',
            data: {action: 'wps_ic_exclude_image', attachment_id: attachment_id},
            success: function (response) {
                // Image data
                $('div#wp-ic-image-' + attachment_id).html(response.data.info);

                // Setup new actions
                $('div#wp-ic-image-actions-' + attachment_id).html(response.data.actions);

                $(parent).show();
                $(loading).hide();
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr.status);
                console.log(xhr.responseText);
                console.log(thrownError);
            }
        });

    });


    /**
     * Restore Background Function
     */
    function wps_ic_background_restore() {
        var next_bulk_time = 1200;
        var button = $('.wps-ic-compress-bulk');
        var results_container = $('.wps-ic-bulk-progress-container');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        if (bulk_restoring == false && bulk_stop == true) {
            wps_ic_bulk_running = false;

            $.ajaxSetup({async: true, cache: false});
            $.post(ajaxurl, {action: 'wps_ic_restore_bulk_stop'}, function (response) {
                if (response.success) {
                    compressing = false;
                    clearInterval(messageInterval);
                    $('div', results_container).hide();
                    $(results_container).append(response.data);
                    //$(info).html(response.data);
                    //$(button).html('Continue').removeClass('wps-ic-bulk-stop');
                    $(button).hide();
                    $('button.wps-ic-compress-bulk').show();
                    window.location.reload();
                } else {
                    alert('Ooops! This is embarrassing... :(');
                }
            });

            return false;
        }

        if (bulk_stop == true) {
            wps_ic_bulk_running = false;
            return false;
        }

        wps_ic_bulk_running = true;

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_background', hash: ic_hash}, function (response) {
            if (response.success) {


                var message_list = $('.wps-ic-bulk-prep');
                $('li:first-child', message_list).hide();
                $('li:last-child', message_list).show();

                $('.wps-ic-spinner').hide();
                $('.wps-ic-bulk-progress').show();

                if (bulk_count >= 5) {
                    bulk_count = 0;
                    next_bulk_time = 2000;

                    console.log('Count >=5 ' + bulk_count);

                }

                updateProgressBar(response.data.status);
                $('.wps-ic-bulk-restored .wps-ic-before-container').show();
                $('.wps-ic-bulk-restored .just-optimized-item img').attr('src', response.data.restored).show();
                $('.wps-ic-bulk-savings').show();
                $('.wps-ic-bulk-savings h3').html(response.data.status.processed_files + '/' + response.data.status.total_files).show();

                if ($(prepare).is(':visible')) {

                    $(info).fadeOut(function () {
                        $(info).html(response.data.html).fadeIn(function () {
                            setTimeout(function () {
                                console.log('Started Next Restore');
                                wps_ic_background_restore();
                            }, next_bulk_time);
                        });
                    });

                } else {
                    $(info).fadeOut(function () {
                        $(info).html(response.data.html);
                    }).fadeIn();
                    setTimeout(function () {
                        console.log('Started Next Restore');
                        wps_ic_background_restore();
                    }, next_bulk_time);
                }

            } else {
                // Nothing
                $(button).html('Compress').removeAttr('disabled');
                clearInterval(messageInterval);

                wps_ic_bulk_running = false;

                // Finished
                $('h1', prepare).html('All Images Restored');

                // Update progress bar
                var obj = JSON.parse('{"total_files":"1","processed_files":"1"}');
                updateProgressBar(obj);

                //
                var container = $('#wps-ic-media-bulk-instructions');
                $('.wps-ic-bulk-not-started', container).hide(function () {
                    $('.wps-ic-bulk-complete', container).fadeIn(500);
                });

                $('h1.wps-ic-compress-not-started', title).show();
                $('h1.wps-ic-compress-started', title).hide();

            }
        });
    }


    /**
     * Compress Background Function
     */
    function wps_ic_background_compress() {
        var next_bulk_time = 1250;
        var button = $('.wps-ic-compress-bulk');
        var results_container = $('.wps-ic-bulk-progress-container');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        if (bulk_stop == true) {
            wps_ic_bulk_running = false;

            $.ajaxSetup({async: true, cache: false});
            $.post(ajaxurl, {action: 'wps_ic_compress_bulk_stop'}, function (response) {
                if (response.success) {
                    compressing = false;
                    clearInterval(messageInterval);
                    $('div', results_container).hide();
                    $(results_container).append(response.data);
                    //$(info).html(response.data);
                    //$(button).html('Continue').removeClass('wps-ic-bulk-stop');
                    $(button).hide();
                    $('button.wps-ic-compress-bulk').show();
                    window.location.reload();
                } else {
                    alert('Ooops! This is embarrassing... :(');
                }
            });

            return false;
        }

        wps_ic_bulk_running = true;

        $.ajaxSetup({async: true, cache: false});
        $.ajax(
            {
                // Define AJAX properties.
                method: "post",
                url: ajaxurl,
                dataType: "json",
                timeout: timeout_ajax,
                data: {action: 'wps_ic_compress_background', hash: ic_hash},
                // Define the succss method.
                success: function (response) {
                    if (response.success) {

                        bulk_count++;

                        if (response.data == 'img_lost') {
                            //alert('Your account has been disabled due to Exceeded Quota Limits!');

                            wps_ic_bulk_running = false;

                            setTimeout(function () {
                                wps_ic_background_compress();
                            }, 1500);

                            return false;
                        }

                        if (response.data == 'blocked') {
                            //alert('Your account has been disabled due to Exceeded Quota Limits!');

                            swal({
                                title: '<strong>Y</strong>',
                                html: 'Your account has been disabled due to Exceeded Quota Limits!',
                                showCloseButton: true,
                                showCancelButton: false,
                                showConfirmButton: false,
                                onClose: function () {
                                    window.location.reload();
                                }
                            });

                            wps_ic_bulk_running = false;
                            //window.location.reload();
                            return false;
                        }

                        if (response.data == 'exhausted resources' ||
                            response.data == 'exhausted resources on api') {
                            //alert('Server resources have been exhausted, please try again later!');

                            bulk_retry++;

                            console.log('Failed ' + bulk_retry);

                            if (bulk_retry >= 5) {
                                $.post(ajaxurl, {action: 'wps_ic_fixing'}, function (response) {
                                });
                                alert('Server resources have been exhausted, please try again later!');
                                wps_ic_bulk_running = false;
                                return false;
                            }

                            setTimeout(function () {
                                wps_ic_background_compress();
                            }, 1500);

                            return false;
                        }

                        bulk_retry = 0;
                        var message_list = $('.wps-ic-bulk-prep');
                        $('li:first-child', message_list).hide();
                        $('li:last-child', message_list).show();

                        $('.wps-ic-spinner').hide();
                        $('.wps-ic-bulk-progress').show();

                        if (bulk_count >= 5) {
                            bulk_count = 0;
                            next_bulk_time = 2000;
                            console.log('Count >=5 ' + bulk_count);
                        }

                        updateProgressBar(response.data.status);
                        updateStatsBox(response.data.stats);


                        if ($(prepare).is(':visible')) {

                            $(info).fadeOut(function () {
                                $(info).html(response.data.html).fadeIn(function () {
                                    setTimeout(function () {
                                        console.log('Started Next');
                                        wps_ic_background_compress();
                                    }, next_bulk_time);
                                });
                            });

                        } else {
                            $(info).fadeOut(function () {
                                $(info).html(response.data.html);
                            }).fadeIn();
                            setTimeout(function () {
                                console.log('Started Next');
                                wps_ic_background_compress();
                            }, next_bulk_time);
                        }

                    } else {
                        // Nothing
                        $(button).html('Compress').removeAttr('disabled');
                        clearInterval(messageInterval);

                        wps_ic_bulk_running = false;

                        // Finished
                        $('h1', prepare).html('Image Optimization Complete');

                        // Update progress bar
                        var obj = JSON.parse('{"total_files":"1","processed_files":"1"}');
                        updateProgressBar(obj);

                        //
                        var container = $('#wps-ic-media-bulk-instructions');
                        $('.wps-ic-bulk-not-started', container).hide(function () {
                            $('.wps-ic-bulk-complete', container).fadeIn(500);
                        });

                        $('h1.wps-ic-compress-not-started', title).show();
                        $('h1.wps-ic-compress-started', title).hide();

                        // Total Saved
                        $.post(ajaxurl, {action: 'wps_ic_compress_total_saved'}, function (response) {

                            // Social Saved
                            var twitter = $('a', '.wps-ic-twitter').attr('href');
                            twitter = twitter.replace('{social_saved}', response.data.saved);
                            $('a', '.wps-ic-twitter').attr('href', twitter);

                            var linkedin = $('a', '.wps-ic-linkedin').attr('href');
                            linkedin = linkedin.replace('{social_saved}', response.data.saved);
                            $('a', '.wps-ic-linkedin').attr('href', linkedin);

                            var mail = $('a', '.wps-ic-mail').attr('href');
                            mail = mail.replace('{social_saved}', response.data.saved);
                            $('a', '.wps-ic-mail').attr('href', mail);

                            $(info).html(response.data.output).fadeIn(function () {
                            });
                        });
                    }
                },
                // Define the error method.
                error: function (objAJAXRequest, strError) {
                    console.log(strError);
                    if (strError == 'timeout') {
                        //alert('Server resources have been exhausted, please try again later!');

                        bulk_retry++;

                        if (bulk_retry >= 5) {
                            $.post(ajaxurl, {action: 'wps_ic_fixing'}, function (response) {
                            });
                            alert('Server resources have been exhausted, please try again later!');
                            wps_ic_bulk_running = false;
                            return false;
                        }

                        setTimeout(function () {
                            wps_ic_background_compress();
                        }, 1500);

                        return false;
                    }

                    bulk_retry = 0;

                }
            }
        );


    }

    /**
     * Compress Bulk Function
     */
    function wps_ic_bulk_compress() {
        var button = $('.wps-ic-compress-bulk');
        var results_container = $('.wps-ic-bulk-progress');
        var prepare = $('.wps-ic-bulk-prep');
        var info = $('.wps-ic-bulk-info');
        var title = $('.wps-ic-media-bulk');

        if (bulk_stop == true) {
            return false;
        }

        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_bulk', hash: ic_hash}, function (response) {
            if (response.success) {


                if (typeof response.data.status !== undefined) {

                    updateProgressBar(response.data.status);
                    updateStatsBox(response.data.stats);

                    if ($(prepare).is(':visible')) {

                        $(info).fadeOut(function () {
                            $(info).html(response.data.html).fadeIn(function () {
                                setTimeout(function () {
                                    wps_ic_bulk_compress();
                                }, 850);
                            });
                        });

                    } else {
                        $(info).fadeOut(function () {
                            $(info).html(response.data.html);
                        }).fadeIn();
                        setTimeout(function () {
                            wps_ic_bulk_compress();
                        }, 850);
                    }

                }

            } else {
                // Nothing
                $(button).html('Compress').removeAttr('disabled');
                clearInterval(messageInterval);

                // Finished
                $('h1', prepare).html('Image Optimization Complete');

                // Update progress bar
                var obj = JSON.parse('{"total_files":"1","processed_files":"1"}');
                console.log(obj);
                updateProgressBar(obj);

                $('h1.wps-ic-compress-not-started', title).show();
                $('h1.wps-ic-compress-started', title).hide();

                // Total Saved
                $.post(ajaxurl, {action: 'wps_ic_compress_total_saved'}, function (response) {

                    // Social Saved
                    var twitter = $('a', '.wps-ic-twitter').attr('href');
                    twitter = twitter.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-twitter').attr('href', twitter);

                    var linkedin = $('a', '.wps-ic-linkedin').attr('href');
                    linkedin = linkedin.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-linkedin').attr('href', linkedin);

                    var mail = $('a', '.wps-ic-mail').attr('href');
                    mail = mail.replace('{social_saved}', response.data.saved);
                    $('a', '.wps-ic-mail').attr('href', mail);

                    $(info).html(response.data.output).fadeIn(function () {
                    });
                });
            }
        });
    }


    /**
     * Update Stats Box
     */
    function updateStatsBox(data) {
        var Box = $('.wps-ic-bulk-savings');
        var Inner = $('.inner', Box);

        $(Inner).html(data);
    }


    /**
     * Update progress bar
     */
    function updateProgressBar(data) {
        var progressBar = $('.wps-ic-bulk-progress-bar');
        var progressBarInner = $('.wps-ic-bulk-progress-bar-inner');
        var progressBarSpan = $('.wps-ic-bulk-progress-bar-inner>span');

        var total = data.total_files;
        var processed = data.processed_files;
        var status = parseInt(processed) / parseInt(total);
        status = status * 100;
        status = Math.round(status).toString();

        if (status >= 48) {
            $(progressBarSpan).addClass('white');
        }

        $(progressBarSpan).html(status + '%');
        $(progressBarInner).css('width', status + '%');

    }


    jQuery('.ic-credit-line').on('click', function (e) {
        e.preventDefault();

        swal({
            title: '',
            html: jQuery('#ic_no_credits_popup').html(),
            width: 900,
            showCloseButton: true,
            showCancelButton: false,
            showConfirmButton: false,
        });
    });

    jQuery('.ic-credit-line-additional').on('click', function (e) {
        e.preventDefault();

        swal({
            title: '',
            width: 900,
            html: jQuery('#ic_additional_credits_popup').html(),
            showCloseButton: true,
            showCancelButton: false,
            showConfirmButton: false,
        });
    });


});

window.onbeforeunload = function () {
    if (saving_settings) {
        return 'Request in progress....are you sure you want to continue?';
    }
};