jQuery(document).ready(function ($) {

    // OLD CODE ABOVE
    var compressIntervalRunning = false;
    var checkRestoreInterval;
    var checkCompressInterval;

    var CompressInterval;
    var RestoreInterval;

    /**
     * Check if there are any images in compress queue
     */
    function doQueue() {
        jQuery.post(ajaxurl, {action: 'compress_heartbeat'}, function (response) {


            if (response.success == false) {
                compressIntervalRunning = false;

                fetchCompressedImages();
                fetchRestoredImages();

                //clearInterval(checkInterval);
                clearInterval(CompressInterval);
                clearInterval(RestoreInterval);
                return false;
            }

            if (typeof response.data.compress_queue !== 'undefined') {
                if (response.data.compress_queue != '') {
                    compressIntervalRunning = true;
                    jQuery.each(response.data.compress_queue, function (attachment_id, value) {

                        jQuery.ajaxSetup({async: true, cache: false});
                        jQuery.post(ajaxurl, {action: 'single_compress', attachment_id: attachment_id}, function (response) {

                            // Start Interval for checking if complete
                            //startCheckInterval();
                            compressInterval();

                        });

                        return false;
                    });
                }
            }

            if (typeof response.data.restore_queue !== 'undefined') {
                if (response.data.restore_queue != '') {
                    compressIntervalRunning = true;
                    jQuery.each(response.data.restore_queue, function (attachment_id, value) {

                        jQuery.ajaxSetup({async: true, cache: false});
                        jQuery.post(ajaxurl, {action: 'single_restore', attachment_id: attachment_id}, function (response) {

                            // Start Interval for checking if complete
                            restoreInterval();

                        });

                        return false;
                    });
                }
            }

        });
    }


    /***
     * Get all compressed images which have not been updated in table
     */
    function fetchCompressedImages() {
        jQuery.post(ajaxurl, {action: 'get_compressed_images'}, function (response) {

            if (response.success == false) {
                clearInterval(CompressInterval);
            }

            jQuery.each(response.data, function (i, item) {
                var row = jQuery('tr#post-' + i);
                var info = jQuery('div#wp-ic-image-' + i);
                var actions = jQuery('div#wp-ic-image-actions-' + i);

                jQuery(info).html(item.info);
                jQuery(actions).html(item.actions);

                jQuery('#wp-ic-image-loading-' + i).hide();
                jQuery(actions).show();
            });
        });
    }


    /***
     * Get all restored images which have not been updated in table
     */
    function fetchRestoredImages() {
        jQuery.post(ajaxurl, {action: 'get_restored_images'}, function (response) {

            if (response.success == false) {
                clearInterval(RestoreInterval);
            }

            jQuery.each(response.data, function (i, item) {
                var row = jQuery('tr#post-' + i);
                var info = jQuery('div#wp-ic-image-' + i);
                var actions = jQuery('div#wp-ic-image-actions-' + i);

                jQuery(info).html(item.info);
                jQuery(actions).html(item.actions);

                jQuery('#wp-ic-image-loading-' + i).hide();
                jQuery(actions).show();
            });
        });
    }


    /***
     * Compress check Interval
     */
    function compressCheckInterval() {
        //compressInterval = setInterval(function () {
            doQueue();
        //, 3000);
    }


    /***
     * Compress check Interval
     */
    function restoreCheckInterval() {
        //restoreInterval = setInterval(function () {
            doQueue();
        //}, 3000);
    }


    /***
     * Check if any images compressed and update them in table
     */
    function startCheckInterval() {
        /*setTimeout(function () {
            fetchCompressedImages();
        }, 2500);

        setTimeout(function () {
            fetchRestoredImages();
        }, 2500);*/



    }


    function compressInterval() {
        clearInterval(CompressInterval);
        CompressInterval = setInterval(function () {
            fetchCompressedImages();
        }, 800);
    }

    function restoreInterval() {
        clearInterval(RestoreInterval);
        RestoreInterval = setInterval(function () {
            fetchRestoredImages();
        }, 800);
    }


    /**
     * Single Image Restore - Click in Media Library
     */
    $('.wps-ic-restore-single').live('click', function (e) {
        e.preventDefault();

        var other_buttons = $('.wps-ic-restore-single');
        $(other_buttons).attr('disabled', 'disabled');

        var button = $(this);
        var attachment_id = $(button).data('image_id');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        /****
         * Send Ajax call to WordPress and save the clicked attachmentID
         * to the Restore Queue for processing
         */
        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_single_btn', attachment_id: attachment_id}, function (response) {

            if (response.success == true) {
                $(other_buttons).removeAttr('disabled');
                restoreCheckInterval();
            }

        });


    });


    /**
     * Single Image Compress - Click in Media library
     */
    $('.wps-ic-compress-single').live('click', function (e) {
        e.preventDefault();

        var other_buttons = $('.wps-ic-compress-single');
        $(other_buttons).attr('disabled', 'disabled');

        var button = $(this);
        var attachment_id = $(button).data('image_id');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        /****
         * Send Ajax call to WordPress and save the clicked attachmentID
         * to the Compress Queue for processing
         */
        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_compress_single', attachment_id: attachment_id}, function (response) {

            if (response.success == true) {
                $(other_buttons).removeAttr('disabled');
                compressCheckInterval();
            }

        });

        return false;
    });


    /***
     * Run on Page Load
     */
    doQueue();

    fetchCompressedImages();
    fetchRestoredImages();


});