jQuery(document).ready(function ($) {


    function unlock_compressing() {
        $.ajax({
            type: "POST",
            url: ajaxurl, //formerly ajaxurl , but changed it because it's not available in the front-end and now we have an option to run in the front-end
            data: {action: 'wps_ic_unlock'},
            success: function (response) {
                setTimeout(function(){ unlock_compressing(); }, 30000);
            },
            error: function () {
                setTimeout(function(){ unlock_compressing(); }, 30000);
            }
        });
    }

    unlock_compressing();


    /**
     * Check Transient Queue for update
     */
    var bulk_running = false;
    function wps_transient_queue() {
        var repeat = function () {

            $.ajax({
                    type: "POST",
                    url: ajaxurl, //formerly ajaxurl , but changed it because it's not available in the front-end and now we have an option to run in the front-end
                    data: {action: 'wps_ic_get_queue'},
                    success: function (response) {

                        var action = '';

                        if (response.success == false || response.success == 'false') {
                            //remove_before_unload();

                            if (response.data.action != 'nothing_to_compress') {
                                if (response.data.action == 'Compressing') {
                                    action = 'Optimization Complete';
                                } else if(response.data.action == 'Regenerating')  {
                                    action = 'Regenerating Complete';
                                } else {
                                    action = 'Restore Complete';
                                }

                                console.log('Total images compressed ' + response.data.queue_done);
                                console.log('Bulk time is ' + response.data.time + ' seconds');
                                console.log('Average compression rate was ' + (response.data.time / response.data.queue_done) + ' seconds per image');

                                $('#ic-background-action-info .wps-ic-btn-text').html(action);
                                $('#ic-background-action-info .wps-ic-loading-white').hide();
                            }

                        } else {

                            //before_unload();

                            $('#ic-background-action-info .wps-ic-btn-text').html(response.data.action + ' ' + response.data.done + ' out of ' + response.data.total + ' images...');
+

                            setTimeout(function () {
                                repeat();
                            }, 5000);
                        }

                    },
                    error: function (response) {


                        //setTimeout(wps_transient_queue(), 3500);

                    }
                }
            );

        };

        repeat();
    }

    wps_transient_queue();

    /**
     * Compress Next In Queue
     */
    var retries = 0;
    function ic_compress_next_in_queue() {

        bulk_running = true;

            $.ajax({
                type: "POST",
                url: ajaxurl,
                cache:false,
                data: {action: 'wps_ic_compress_next_in_queue', hash:new Date().getTime()},
                success: function (response) {

                    bulk_running = false;

                    if (response.success == false || response.success == 'false') {
                        //remove_before_unload();

                        retries++;
                        //console.log('Retry: ' + retries);
                        if (retries<=5) {
                            setTimeout(function () {
                                ic_compress_next_in_queue();
                            }, 4000+(retries*500));
                        } else {
                            retries = 0;
                        }

                    } else {

                        console.log('Finished attachments ' + response.data.attachments + ' in '+ response.data.time + ' seconds');

                        if (response.data.action == 'compress') {
                            setTimeout(function () {
                                ic_compress_fetch_thumbs(response.data.attachments);
                            }, 3500);
                        }

                        setTimeout(function () {
                            ic_compress_next_in_queue();
                        }, 2000);

                    }

                },
                error: function (response) {

                    setTimeout(function () {
                        ic_compress_next_in_queue_last();
                    }, 2000);

                }
            });


    }


    function ic_compress_next_in_queue_last() {
        bulk_running = true;

        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: {action: 'wps_ic_compress_next_in_queue_last_three'},
            success: function (response) {

                bulk_running = false;

                if (response.success == false || response.success == 'false') {
                    //remove_before_unload();

                    retries++;
                    console.log('Retry: ' + retries);
                    if (retries<=5) {
                        setTimeout(function () {
                            ic_compress_next_in_queue();
                        }, 4000+(retries*500));
                    } else {
                        retries = 0;
                    }

                } else {

                    console.log('Finished attachments ' + response.data.attachments + ' in '+ response.data.time + ' seconds');

                    if (response.data.action == 'compress') {
                        setTimeout(function () {
                            ic_compress_fetch_thumbs(response.data.attachments);
                        }, 3500);
                    }

                    setTimeout(function () {
                        ic_compress_next_in_queue();
                    }, 2000);

                }

            },
            error: function (response) {

                setTimeout(function () {
                    ic_compress_next_in_queue_last();
                }, 2000);

            }
        });
    }


    function ic_compress_fetch_thumbs(attachments) {
        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: {action: 'wps_ic_compress_fetch_thumbnails', attachments: attachments},
            success: function (response) {

            }
        });
    }


    ic_compress_next_in_queue();

});