jQuery(document).ready(function ($) {

    $('.dropdown-toggle').live('click', function () {
        var btn = $(this);
        var group = $(this).parent();
        $(group).toggleClass('open');
    });

    /**
     * Before Unload function
     */

    /**
     * Compress Next In Queue
     */
    function library_compress_next_in_queue() {

        $.ajax({
                type: "POST",
                url: ajaxurl,
                data: {action: 'wps_ic_library_compress_next_in_queue'},
                success: function (response) {

                    if (response.success == false || response.success == 'false') {
                    } else {

                        setTimeout(function () {
                            library_compress_next_in_queue();
                        }, 2500);
                    }

                },
                error: function (response) {
                    setTimeout(function () {
                        library_compress_next_in_queue();
                    }, 2500);
                }
            }
        );

    }

    //ic_compress_next_in_queue();


    function anythingQueued() {

        jQuery.post(ajaxurl, {action: 'get_library_queued_images'}, function (response) {

            if (response.success == 'true' || response.success == true) {
                library_compress_next_in_queue();
            }

            fetchLibraryCompressedImages();
            fetchLibraryRestoredImages();
            //fetchUnCompressedImages();

        });

    }


    /***
     * Get all compressed images which have not been updated in table
     */
    function fetchLibraryCompressedImages() {
        jQuery.post(ajaxurl, {action: 'get_library_compressed_images'}, function (response) {

            if (response.data == 'compressing') {
                return true;
            }

            console.log('Compressed images: ');
            console.log(response.data);

            jQuery.each(response.data, function (i, item) {
                var row = jQuery('tr#post-' + i);
                var info = jQuery('div#wp-ic-image-' + i);
                var actions = jQuery('div#wp-ic-image-actions-' + i);

                jQuery(info).html(item.info);
                jQuery(actions).html(item.actions);

                jQuery('#wp-ic-image-loading-' + i).hide();
                jQuery(actions).show();
                //doQueue();
            });
        });
    }



    /***
     * Get all restored images which have not been updated in table
     */
    function fetchLibraryRestoredImages() {
        jQuery.post(ajaxurl, {action: 'get_library_restored_images'}, function (response) {


            if (response.data == 'restoring') {
                return true;
            }

            jQuery.each(response.data, function (i, item) {
                var row = jQuery('tr#post-' + i);
                var info = jQuery('div#wp-ic-image-' + i);
                var actions = jQuery('div#wp-ic-image-actions-' + i);

                jQuery(info).html(item.info);
                jQuery(actions).html(item.actions);

                jQuery('#wp-ic-image-loading-' + i).hide();
                jQuery(actions).show();
                //doQueue();
            });
        });
    }

    /**
     * Single Image Restore - Click in Media Library
     */
    $('.wps-ic-restore-single').live('click', function (e) {
        e.preventDefault();

        var other_buttons = $('.wps-ic-restore-single');
        $(other_buttons).attr('disabled', 'disabled');

        setTimeout(function () {
            $(other_buttons).removeAttr('disabled');
        }, 350);

        var button = $(this);
        var attachment_id = $(button).data('image_id');
        var type = $(button).data('type');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        /****
         * Send Ajax call to WordPress and save the clicked attachmentID
         * to the Restore Queue for processing
         */
        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_restore_single_btn', attachment_id: attachment_id, type: type}, function (response) {

            if (response.success == true) {

                $.ajax({
                    type: "POST",
                    url: ajaxurl,
                    data: {action: 'wps_ic_compress_next_in_queue'},
                    success: function (response) {
                        anythingQueued();
                    },
                    error: function (response) {
                    }
                });
            }

        });


    });

    //ic_compress_fetch_thumbs([1314]);

    /**
     * Single Image Compress - Click in Media library
     */
    $('.wps-ic-compress-single').live('click', function (e) {
        e.preventDefault();

        var other_buttons = $('.wps-ic-compress-single');
        $(other_buttons).attr('disabled', 'disabled');

        setTimeout(function () {
            $(other_buttons).removeAttr('disabled');
        }, 350);

        var button = $(this);
        var attachment_id = $(button).data('image_id');

        var parent = $('#wp-ic-image-actions-' + attachment_id);
        var loading = $('#wp-ic-image-loading-' + attachment_id);

        $(parent).hide();
        $(loading).show();

        /****
         * Send Ajax call to WordPress and save the clicked attachmentID
         * to the Compress Queue for processing
         */
        $.ajaxSetup({async: true, cache: false});
        $.post(ajaxurl, {action: 'wps_ic_single_compress_btn', attachment_id: attachment_id}, function (response) {

            if (response.success == true) {

                setTimeout(function () {
                    anythingQueued();
                }, 1000);

                setTimeout(function () {
                    console.log('Total thumbs :' + response.data.thumbs);
                    console.log('Fetch Thumbnails: ' + response.data.attachments);
                    ic_compress_fetch_thumbs(response.data.attachments);
                }, 3500);

                $.ajax({
                    type: "POST",
                    url: ajaxurl,
                    data: {action: 'wps_ic_compress_next_in_queue'},
                    success: function (response) {
                        //anythingQueued();
                    },
                    error: function (response) {
                    }
                });

            } else {

            }

        });

        return false;
    });


    function ic_compress_fetch_thumbs(attachments) {

        $.ajax({
            type: "POST",
            url: ajaxurl,
            data: {action: 'wps_ic_compress_fetch_thumbnails', attachments: attachments},
            success: function (response) {

            }
        });
    }


});