jQuery(document).ready(function ($) {


    /**
     * @since 3.3.0
     */
    $('.whole-checkbox>div').on('click', function (e) {
        e.preventDefault();

        saving_settings = true;
        var parent = $(this).parent();
        var input = $('input', parent);
        var setting = $(input).data('setting_name');
        var value = $(input).data('setting_value');
        var checked = $(input).is(':checked');
        var informative = $('span', parent);
        var div = $(parent);

        if ($(input).is(':checked')) {
            $(input).removeAttr('checked');
            checked = false;
            value = 0;
            if (!$(informative).hasClass('no-change')) {
                $(informative).html('OFF');
            }
        } else {
            $(input).attr('checked', 'checked');
            checked = true;
            value = 1;

            if (!$(informative).hasClass('no-change')) {
                $(informative).html('ON');
            }
        }

        // Is AutoPilot?
        if (setting == 'autopilot') {
            if ($(input).is(':checked')) {

                $(div).css('padding-top','13px');

                $('.wp-ic-select-box.disabled').hide();
                $('.wp-ic-select-box.enabled').show();

            } else {

                $(div).css('padding-top','40px');

                $('.wp-ic-select-box.disabled').show();
                $('.wp-ic-select-box.enabled').hide();

            }
        }

        // Show CDN scanning popup
        if (setting == 'cdn' && value == 1 && checked == true) {
            show_cdn_popup();
        }


        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: setting, value: value, checked: checked, checkbox:true}, function (response) {
            if (response.success) {
                // Nothing
                saving_settings = false;
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });
    });


    /**
     * @since 3.3.0
     */
    $('.wp-ic-ajax-checkbox-v2').on('click', function (e) {
        e.preventDefault();

        saving_settings = true;
        var parent = $(this).parent().parent();
        var input = $('input', parent);
        var setting = $(input).data('setting_name');
        var value = $(input).data('setting_value');
        var checked = $(input).is(':checked');
        var informative = $('span', parent);

        if ($(input).is(':checked')) {
            $(input).removeAttr('checked');
            checked = false;
            value = 0;
            if (!$(informative).hasClass('no-change')) {
                $(informative).html('OFF');
            }
        } else {
            $(input).attr('checked', 'checked');
            checked = true;
            value = 1;

            if (!$(informative).hasClass('no-change')) {
                $(informative).html('ON');
            }
        }

        // Show CDN scanning popup
        if (setting == 'cdn' && value == 1 && checked == true) {
            show_cdn_popup();
        }

        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: setting, value: value, checked: checked, checkbox:true}, function (response) {
            if (response.success) {
                // Nothing
                saving_settings = false;
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });
    });


    /**
     * @since 3.3.0
     */
    $('.wp-ic-ajax-input').focusout(function (e) {
        e.preventDefault();

        var parent = $(this).parent();
        var input = $('input', parent);
        var setting = $(input).data('setting_name');
        var value = $(input).attr('value');

        $.post(ajaxurl, {action: 'wps_ic_settings_change', what: setting, value: value, checked: false, checkbox:false}, function (response) {
            if (response.success) {
                // Nothing
            } else {
                alert('Oops! We weren\'t able to save your settings! :(');
            }
        });
    });


});