<?php


class wps_ic_adaptive extends wps_ic {


  public function __construct() {
    #add_action('wp_head', 'ai_cookie_javascript', 0);
    $ai = new wps_addon_adaptive();
  }


  /**
   * Set a cookie with users screen resolution
   */
  public function ai_cookie_javascript() {

    $options = get_option('adaptive-images'); ?>

    <!--wp-ic-adaptive-->
    <script type="text/javascript">
        var screen_width = Math.max(screen.width, screen.height);
        var devicePixelRatio = window.devicePixelRatio ? window.devicePixelRatio : 1;
        document.cookie = 'resolution=' + screen_width + ',' + devicePixelRatio + '; path=/';
    </script>
    <!--/wp-ic-adaptive-->
    <?php

  }


  /**
   * Is htaccess writeable
   */
  public function ai_is_htaccess_writeable() {

    $htaccess = adaptive_images_plugin_get_htaccess_file_path();

    return
      ( ! file_exists($htaccess) && @fopen($htaccess, 'w')) ||
      (file_exists($htaccess) && is_writable($htaccess));

  }


  /**
   * Write htaccess
   */
  public function adaptive_images_actions_get_htaccess_block($data) {

    // Get the directory part of the request
    $request_uri      = $_SERVER['REQUEST_URI'];
    $request_uri_base = substr($request_uri, 0, strpos($request_uri, '/wp-admin', 1));

    // Isolate the relative path
    $wp_home_path = get_home_path();

    $wp_home_path = preg_replace('/\//i', '\/', $wp_home_path);
    $wp_home_path = preg_replace('/\./i', '\\.', $wp_home_path);

    $ai_dir_path          = dirname(__FILE__);
    $ai_dir_path_relative = preg_replace('/' . $wp_home_path . '/i', '', $ai_dir_path);

    $ai_php_script = ($request_uri_base != '' ? $request_uri_base : '') . '/' . $ai_dir_path_relative . '/addons/adaptive/adaptive.php';

    if (strpos($ai_php_script, '/') !== 0) {
      $ai_php_script = '/' . $ai_php_script;
    }

    // Watched directories .htaccess.
    $htaccess_rewrite_block =
      "# Image Compress Adaptive \n" .
      "#=======================\n" .
      "\n" .
      "<IfModule mod_rewrite.c>\n" .
      "\n" .
      "    RewriteEngine On\n" .
      "\n" .
      "    # Watched \n";

    for ($k = 0, $length = count($data['watched-directories']); $k < $length; $k ++) {

      $watched_directory = $data['watched-directories'][ $k ];

      $htaccess_rewrite_block .=
        "    RewriteCond %{REQUEST_URI} " . $request_uri_base . '/' . $watched_directory . ($k < $length - 1 ? ' [OR]' : "\n") . "\n";

    }

    $htaccess_rewrite_block .=
      "    # Redirect images through script\n" .
      "    RewriteRule \.(?:jpe?g|gif|png)$ " . $ai_php_script . " [L]\n" .
      "\n" .
      "</IfModule>\n" .
      "\n" .
      "# Image Compress Adaptive";

    return $htaccess_rewrite_block;

  }

}