<?php


/**
 * Class - Enqueues
 */
class wps_ic_enqueues extends wps_ic {

  public static $version;
  public static $slug;


  public function __construct() {
    $this::$version = '4.1.0';
    add_action('wp_print_scripts', array($this, 'print_header_scripts'));
    add_action('wp_enqueue_scripts', array($this, 'enqueue_frontend'));
    add_action('admin_enqueue_scripts', array($this, 'enqueue_all'));
  }


  public function print_header_scripts() {
    if (!is_admin()) {
      global $post;
      echo '<script type="text/javascript">';
      echo 'setTimeout(function(){ writeCookie(); }, 300); 
    function writeCookie() { 
    var today = new Date(); 
    var the_date = new Date("December 31, 2023"); 
    var the_cookie_date = the_date.toGMTString(); 
    var the_cookie = "ic_window_resolution_' . $post->ID . '="+ window.innerWidth; 
    var the_cookie = the_cookie + ";expires=" + the_cookie_date; 
    document.cookie=the_cookie }';
      echo '</script>';
    }
  }


  public function enqueue_frontend() {
    $options = get_option(WPS_IC_SETTINGS);

    if (( ! empty($options['cdn']) && $options['cdn'] == '1')
        || ( ! empty($options['adaptive_images']) && $options['adaptive_images'] == '1')
        || ( ! empty($options['lazy']) && $options['lazy'] == '1')
        || ( ! empty($options['generate_webp']) && $options['generate_webp'] == '1')) {
      wp_enqueue_script($this::$slug . '-lazy-load-observer', 'https://plugin.wpcompress.xyz/observer.min.js', array('jquery'), $this::$version, true);
      wp_enqueue_script($this::$slug . '-lazy-load', 'https://plugin.wpcompress.xyz/lazyload.min.js', array('jquery'), $this::$version, true);

      wp_enqueue_script($this::$slug . '-cdnlazy-load', 'https://plugin.wpcompress.xyz/cdn-frontend.min.js', array('jquery'), $this::$version, true);

      wp_enqueue_style($this::$slug . '-lazy', 'https://plugin.wpcompress.xyz/lazy.min.css', array(), $this::$version);
    }

  }


  public function enqueue_all() {
    $this::$version = parent::$version;
    $this::$slug    = parent::$slug;
    $response_key   = parent::$response_key;

    $screen = get_current_screen();

    $this->asset_style('menu-icon', 'css/menu.wp' . WPS_IC_MIN . '.css');

    if ($screen->base != 'upload' && $screen->base != 'toplevel_page_wpcompress-network' && $screen->base != 'toplevel_page_wpcompress' && $screen->base != 'media_page_wpcompress_optimize' && $screen->base != 'media_page_wpcompress_restore' &&
        $screen->base != 'plugins') {


    } else {

      if (is_admin()) {

        if ($screen->base == 'toplevel_page_wpcompress' || $screen->base == 'toplevel_page_wpcompress-network') {

          if (!empty($response_key)) {
            // Bulk Script
            $this->script('bulk-check', 'bulk.admin' . WPS_IC_MIN . '.js');
          }

          // Switch Box - Checkbox customizer
          $this->script('switchbox', 'switchbox' . WPS_IC_MIN . '.js');

          // Settings Area
          $this->script('admin-settings', 'settings.admin' . WPS_IC_MIN . '.js');

          if (is_multisite()) {
            $this->script('admin-mu-settings', 'mu-settings.admin' . WPS_IC_MIN . '.js');
          }

          // Font awesome
          $this->asset_style('admin-fontawesome', 'fontawesome/css/all.min.css');
        }

        if ( ! empty($response_key)) {


          // Media Library - Bulk Area
          if ($screen->base == 'media_page_wpcompress_optimize' || $screen->base == 'media_page_wpcompress_restore' || $screen->base == 'media_page_wp_hard_restore_bulk') {

            // Font awesome
            $this->asset_style('admin-fontawesome', 'fontawesome/css/all.min.css');

          }

          // Media Library Area
          if ($screen->base == 'upload' || $screen->base == 'media_page_wpcompress_optimize' || $screen->base == 'plugins' || $screen->base == 'media_page_wpcompress_restore' || $screen->base == 'media_page_wp_hard_restore_bulk') {

            // Fontawesome
            $this->asset_style('admin-fontawesome', 'fontawesome/css/all.min.css');

            $this->script('media-library', 'media-library' . WPS_IC_MIN . '.js');
          }


          if ($screen->base == 'toplevel_page_wpcompress' || $screen->base == 'toplevel_page_wpcompress-network' || $screen->base == 'upload' || $screen->base == 'media_page_wpcompress_optimize' || $screen->base == 'plugins' || $screen->base == 'media_page_wpcompress_restore' || $screen->base == 'media_page_wp_hard_restore_bulk') {

            $this->script('admin', 'admin' . WPS_IC_MIN . '.js');
            $this->script('cdn', 'cdn' . WPS_IC_MIN . '.js');
            $this->script('admin-scripts', 'scripts' . WPS_IC_MIN . '.js');

            // Google Fonts
            wp_enqueue_style($this::$slug . '-google-font-sans', 'https://fonts.googleapis.com/css?family=Poppins:100,200,300,400,500,600,700', array(), $this::$version);
            wp_enqueue_style($this::$slug . '-google-font-sans', 'https://fonts.googleapis.com/css?family=Open+Sans', array(), $this::$version);
          }

        }

        if ($screen->base == 'toplevel_page_wpcompress') {

          #$this->asset_style('admin-tooltip-wcio', 'tooltip/css/tooltipster.main.min.css');
          $this->asset_style('admin-tooltip-bundle-wcio', 'tooltip/css/tooltipster.bundle.min.css');
          $this->asset_script('admin-tooltip', 'tooltip/js/tooltipster.bundle.min.js');

          // Fontello
          $this->asset_style('admin-fontello', 'icons/css/fontello.css');
        }

        if ($screen->base == 'toplevel_page_wpcompress' || $screen->base == 'toplevel_page_wpcompress-network' || $screen->base == 'upload' || $screen->base == 'media_page_wpcompress_optimize' || $screen->base == 'plugins' || $screen->base == 'media_page_wpcompress_restore' || $screen->base == 'media_page_wp_hard_restore_bulk') {

          $this->style('admin-media-library', 'admin.media-library' . WPS_IC_MIN . '.css');
          $this->style('admin-notices', 'admin.notices' . WPS_IC_MIN . '.css');
          $this->style('admin', 'admin.styles' . WPS_IC_MIN . '.css');
          $this->style('admin-toggle', 'admin.toggle' . WPS_IC_MIN . '.css');
          $this->style('admin-animations', 'animate' . WPS_IC_MIN . '.css');
          $this->style('admin-settings-page', 'settings_page' . WPS_IC_MIN . '.css');
          $this->asset_script('admin-settings-page-progress-bar', 'progress/progressbar' . WPS_IC_MIN . '.js');
          $this->asset_script('admin-settings-page-charts', 'charts/Chart.bundle' . WPS_IC_MIN . '.js');
          $this->asset_script('admin-settings-popup', 'js/settings.popup.js');

          // Sweetalert
          $this->asset_style('admin-sweetalert', 'sweetalert/sweetalert2.min.css');
          $this->asset_script('admin-sweetalert', 'sweetalert/sweetalert2.min.js');

        }

        // Print footer script
        wp_localize_script('wps_ic-admin', 'wps_ic', array('uri' => WPS_IC_URI));
      }

    }

  }


  public function script($name, $filename) {
    wp_enqueue_script($this::$slug . '-' . $name, WPS_IC_URI . 'assets/js/' . $filename, array('jquery'), $this::$version, true);
  }


  public function style($name, $filename) {
    wp_enqueue_style($this::$slug . '-' . $name, WPS_IC_URI . 'assets/css/' . $filename, array(), $this::$version);
  }


  public function asset_style($name, $filename) {
    wp_enqueue_style($this::$slug . '-' . $name, WPS_IC_URI . 'assets/' . $filename, array(), $this::$version);
  }


  public function asset_script($name, $filename) {
    wp_enqueue_script($this::$slug . '-' . $name, WPS_IC_URI . 'assets/' . $filename, array('jquery'), $this::$version, true);
  }


}