<?php


class wps_ic_log extends wps_ic {

  public static $log_path;

  public function __construct() {
    $this::$log_path = WPS_IC_DIR;
  }


  public function reset() {
    $log_file = $this::$log_path . 'log.txt';
    $fp       = fopen($log_file, 'w');
    fclose($fp);

    global $wpdb;
    $wpdb->query("TRUNCATE " . $wpdb->prefix . 'ic_log');

  }


  public function view() {
    global $wpdb;

    if (!empty($_GET['clear_log'])) {
      $wpdb->query("TRUNCATE TABLE " . $wpdb->prefix . "ic_log");
    }

    if (empty($_GET['attachment_ID'])) {
      $log = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "ic_log GROUP BY attachment_ID ORDER by ID DESC");
    } else {
      $attachment_ID = sanitize_text_field($_GET['attachment_ID']);
      $log = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "ic_log WHERE attachment_ID='" . $attachment_ID . "' ORDER by ID DESC");
    }

    if ($log) {
      echo '<div class="wrap">';
      echo '<h2>Debug Log</h2>';
      echo '<table class="wp-list-table widefat fixed striped pages">';

      if (empty($_GET['attachment_ID'])) {
        echo '<thead>';
        echo '<tr>';
        echo '<th>Attachment ID</th>';
        echo '<th>Attachment Thumbnail</th>';
        echo '<th>Log Status</th>';
        echo '<th>View</th>';
        echo '</tr>';
        echo '</thead>';
        echo '<tbody>';
        foreach ($log as $item) {

          if ($item->attachment_ID != 0) {
            $img = wp_get_attachment_image_src($item->attachment_ID, 'thumbnail');
            $img = '<img src="' . $img[0] . '" style="width:150px;" />';

            if ($item->status == '1') {
              $status = 'OK';
            } else {
              $status = 'BAD';
            }

            echo '<tr>';
            echo '<td>' . $item->attachment_ID . '</td>';
            echo '<td>' . $img . '</td>';
            echo '<td>' . $status . '</td>';
            echo '<td><a href="' . admin_url('admin.php?page=wpcompress&view_debug_log=true&attachment_ID=' . $item->attachment_ID) . '">View</a></td>';
            echo '</tr>';
          } else {
            /* echo '<tr>';
             echo '<td>Thumbnail Generating</td>';
             echo '<td>-</td>';
             echo '<td>' . $item->message . '</td>';
             echo '<td><a href="#">View</a></td>';
             echo '</tr>';*/
          }
        }

      } else {

        echo '<thead>';
        echo '<tr>';
        echo '<th>Attachment ID</th>';
        echo '<th>Attachment Thumbnail</th>';
        echo '<th>Message</th>';
        echo '<th>Type</th>';
        echo '</tr>';
        echo '</thead>';
        echo '<tbody>';
        foreach ($log as $item) {

          if ($item->attachment_ID != 0) {
            $img = wp_get_attachment_image_src($item->attachment_ID, 'thumbnail');
            $img = '<img src="' . $img[0] . '" style="width:150px;" />';

            if ($item->status == '1') {
              $status = 'OK';
            } else {
              $status = 'BAD';
            }

            echo '<tr>';
            echo '<td>' . $item->attachment_ID . '</td>';
            echo '<td>' . $img . '</td>';
            echo '<td>' . $item->message . '</td>';
            echo '<td>' . $item->type . '</td>';
            echo '</tr>';
          } else {
            /* echo '<tr>';
             echo '<td>Thumbnail Generating</td>';
             echo '<td>-</td>';
             echo '<td>' . $item->message . '</td>';
             echo '<td><a href="#">View</a></td>';
             echo '</tr>';*/
          }
        }

      }
      echo '</tbody>';
      echo '</table>';
      echo '</div>';
    } else {
      echo '<div class="wrap">';
      echo '<h2>There are no log entries!</h2>';
      echo '</div>';
    }

  }


  public function write($event, $message, $file = 'log.txt', $force = false) {

    if ( ! WPS_IC_DEBUG || $force) {

      $log_file = $this::$log_path . $file;

      if ( ! file_exists($log_file)) {
        fopen($log_file, 'w');
      }

      $log = file_get_contents($log_file);

      if ($message == '-') {
        $log .= '--' . "\r\n";
      } else {
        if (!is_object($message) && !is_object($event)) {
          $log .= '[' . date('d.m.Y H:i:s') . '] Event occured: ' . $event . ' - ' . $message . "\r\n";
        }
      }
      file_put_contents($log_file, $log);

    }
  }


  public function write_log($attachment_ID, $message, $action = 'log') {
    if (get_option('wps_ic_debug') == 'true') {
      $log_file = $this::$log_path . $action . '-' . date('d-m-Y') . '.txt';
      $time     = current_time('mysql');

      if ( ! file_exists($log_file)) {
        fopen($log_file, 'a');
      }

      $log = file_get_contents($log_file);
      $log .= '[' . $time . '] - Attachment ID: ' . $attachment_ID . ' - ' . $message . "\r\n";
      file_put_contents($log_file, $log);
    }
  }


}