<?php

#error_reporting(E_ALL);
#ini_set('display_errors', '1');

class wps_ic_mainwp extends wps_ic {


  public function __construct() {
    add_action('send_headers', array(__CLASS__, 'admin_init_mainwp'));
    add_action('send_headers', array(__CLASS__, 'check_mainwp'));
  }


  public static function check_mainwp() {
    if (!empty($_GET['check_mainwp'])) {
      $options = get_option(WPS_IC_OPTIONS);
      if (!empty($options['api_key'])) {
        wp_send_json_success();
      } else {
        wp_send_json_error();
      }
    }
  }


  public static function admin_init_mainwp() {

    if (!empty($_GET['force_ic_connect'])) {
      $apikey = sanitize_text_field($_POST['apikey']);

      // Setup URI
      $uri = WPS_IC_KEYSURL;
      $uri .= '?action=connect';
      $uri .= '&apikey=' . $apikey;
      $uri .= '&site=' . urlencode(site_url());
      $uri .= '&affiliate_code=';
      $uri .= '&override_check=true';

      // Verify API Key is our database and user has is confirmed getresponse
      $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

      if (wp_remote_retrieve_response_code($get) == 200) {
        $body = wp_remote_retrieve_body($get);
        $body = json_decode($body);

        if ($body->success == true && $body->data->api_key != '' && $body->data->response_key != '') {
          $options = get_option(WPS_IC_OPTIONS);
          $options['api_key'] = $body->data->api_key;
          $options['response_key'] = $body->data->response_key;
          $options['orp'] = $body->data->orp;
          update_option(WPS_IC_OPTIONS, $options);

          $settings = get_option(WPS_IC_SETTINGS);

          $sizes = get_intermediate_image_sizes();
          foreach ($sizes as $key => $value) {
            $settings['thumbnails'][ $value ] = 1;
          }

          update_option(WPS_IC_SETTINGS, $settings);

          //delete_option('wps_ic_affiliate_code');
          wp_send_json_success();
        }

        wp_send_json_error($body->data);
      }

      wp_send_json_error('0');
    }

  }



}