<?php


/**
 * Class - Menu
 */
class wps_ic_menu extends wps_ic {

  public $templates;
  public static $slug;


  public function __construct() {

    $this::$slug = parent::$slug;

    if (is_admin()) {
      $this->templates = new wps_ic_templates();
      add_action('admin_menu', array($this, 'menu_init'));

      if (is_multisite()) {
        // TODO
        #add_action('network_admin_menu', array($this, 'multisite_menu'));
      }

    }

  }


  public function multisite_menu() {
    add_menu_page('WP Compress', 'WP Compress', 'manage_options', $this::$slug, array($this, 'render_mu_admin_page'));
  }


  public function set_screen_options($status, $option, $value) {

    if ('wps_ic_show' == $option) {

      $options = get_option(WPS_IC_SETTINGS);

      if ( ! empty($_POST['wps_ic_show_check'])) {
        $options['hide_compress'] = '0';
      } else {
        $options['hide_compress'] = '1';
      }

      update_option(WPS_IC_SETTINGS, $options);

      return $value;

    }

    return $status;
  }


  public function show_screen_options($status, $args) {
    $return = $status;
    if ($args->base == 'upload') {

      $return .= "
            <fieldset>
            <legend>WP Compress</legend>
            <div class='metabox-prefs'>
            <div><input type='hidden' name='ic_screen_options[option]' value='wps_ic_show' /></div>
            <div><input type='hidden' name='ic_screen_options[value]' value='yes' /></div>
            <div class='cmi_custom_fields'>";

      $options = get_option(WPS_IC_SETTINGS);
      if (empty($options['hide_compress']) || $options['hide_compress'] == '0') {
        $return .= "<label for='cmi_producer'><input type='checkbox' value='on' checked='checked' name='wps_ic_show_check[]' id='cmi_producer' /> Show</label>";
      } else {
        $return .= "<label for='cmi_producer'><input type='checkbox' value='on' name='wps_ic_show_check[]' id='cmi_producer' /> Show</label>";
      }

      $return .= "</div>
            </div>
            </fieldset>";
    }

    return $return;
  }


  public function menu_init() {
    add_menu_page('WP Compress', 'WP Compress', 'manage_options', $this::$slug, array($this, 'render_admin_page'));
  }


  public function render_mu_admin_page() {
    global $wps_ic;
    $this->templates->get_admin_page('mu-getting-started');
  }


  public function render_admin_page() {

    global $wps_ic;

    /**
     * Reset Debug Log
     */
    if ( ! empty($_GET['reset_debug_log'])) {
      $wps_ic->log->reset();
    }

    /**
     * View Debug Log
     */
    if ( ! empty($_GET['view_debug_log'])) {
      $wps_ic->log->view();
      die();
    }


    $response_key = $wps_ic->options->get_option('response_key');
    if (empty($response_key) || !$response_key) {
      $this->templates->get_admin_page('getting-started');
    } else {

      if (empty($_GET['debug'])) {
        $this->templates->get_admin_page('main');
      } else {
        $this->templates->get_admin_page('debug');
      }
    }
  }


  public function render_bulk_page() {
    $this->templates->get_admin_page('bulk');
  }


  public function render_bulk_restore_page() {
    $this->templates->get_admin_page('bulk_restore');
  }


  public function render_bulk_hard_restore_page() {
    $this->templates->get_admin_page('bulk_hard_restore');
  }


}