<?php


/**
 * Class - Ajax
 */
class wps_ic_ajax extends wps_ic {

  public $options;


  public function __construct() {
    if (is_admin()) {

      // API Url
      #parent::$total_referrals = $this->wps_ic_api_referrals();

      // Deauthorize with remote API
      #$this->add_ajax('wps_ic_deauthorize_api');

      if ( ! empty(parent::$response_key)) {

        $this->add_ajax('wps_ic_any_thumbnails_to_rebuild');
        $this->add_ajax('wps_ic_compress_fetch_thumbnails');
        $this->add_ajax('wps_ic_setup_rebuild_cron');
        $this->add_ajax('wps_ic_regenerate_thumbs');
        $this->add_ajax('wps_ic_rebuild_image');

        $this->add_ajax('get_queued_images');
        $this->add_ajax('get_compressed_images');
        $this->add_ajax('get_restored_images');
        $this->add_ajax('get_reset_images');

        $this->add_ajax('ic_is_compress_done');
        $this->add_ajax('compress_heartbeat');
        $this->add_ajax('wps_ic_compress_background_cron');

        $this->add_ajax('wps_ic_api_check_credits');
        $this->add_ajax('wps_ic_api_referrals');
        $this->add_ajax('wps_ic_compress_hidden_bulk');

        // Change Setting
        $this->add_ajax('wps_ic_settings_change');
        $this->add_ajax('wps_ic_get_setting');
        $this->add_ajax('wps_ic_get_thumbnail_checkboxes');
        $this->add_ajax('wps_ic_notify');

        // CDN
        $this->add_ajax('check_cdn_status');
        $this->add_ajax('resync_cdn');
        $this->add_ajax('reset_cdn_cache');

        // Compress
        $this->add_ajax('wps_ic_compress_bulk_prep_hidden_background');
        $this->add_ajax('wps_ic_compress_bulk_prep_background');

        // Restore 3.3.0
        $this->add_ajax('wps_ic_restore_single');

        // Restore Bulk
        $this->add_ajax('wps_ic_restore_bulk_prep_background_hidden');
        $this->add_ajax('wps_ic_restore_hidden_bulk');

        // Exclude Image from Compress
        $this->add_ajax('wps_ic_exclude_image');

        // Get the Queue Status
        $this->add_ajax('wps_ic_compress_next_in_queue');
        $this->add_ajax('wps_ic_get_queue');

        $this->add_ajax('wps_ic_wake_up_cron');

        // MAYBE DELETE
        $this->add_ajax('wps_ic_compress_single');

        // Single Image Actions
        $this->add_ajax('single_restore');
        $this->add_ajax('single_compress');

        // Restore the image - single
        $this->add_ajax('wps_ic_restore_single_btn');
        $this->add_ajax('wps_ic_restore_attachment');
        // ABOVE MAYBE DELETE

      } else {
        // API Signup
        $this->add_ajax('wps_ic_api_signup');
        $this->add_ajax('wps_ic_api_connect');
        $this->add_ajax('wps_ic_api_test');

        // Authorize with remote API
        $this->add_ajax('wps_ic_authorize_api');
      }
    }

    #delete_option('wps_ic_rebuild_started');
  }


  public function reset_cdn_cache() {
    global $wpdb;
    // First check if CDN Zone already exists
    $options = get_option(WPS_IC_OPTIONS);
    $call    = wp_remote_get(WPS_IC_APIURL . '?cdn_purge=true&domain=' . site_url() . '&apikey=' . $options['api_key'], array('timeout' => '10', 'sslverify' => false));

    if (wp_remote_retrieve_response_code($call) == 200) {
      $body = wp_remote_retrieve_body($call);
      $body = json_decode($body);

      if ($body->success == 'true') {
        $cache = $wpdb->query("DELETE FROM " . $wpdb->postmeta . " WHERE meta_key='_ic_sources' OR meta_key='_ic_cdn_content'");
        set_transient('ic_cdn_reset_cache', 'true', 60);

        // CDN Suspended (bandwidth)
        $output = '';
        $output .= '<img src="' . WPS_IC_URI . 'assets/thumbnails-config.png" style="margin-top: 15px;"/>';

        $output .= '<h3>Your CDN Account has been successfully purged.</h3>';
        $output .= '<p>Please allow few minutes for cache reset on global network.</p>';

        wp_send_json_success(array('html' => $output));
      } else {
        // CDN Does not exist,error
        $output = '';
        $output .= '<img src="' . WPS_IC_URI . 'assets/thumbnails-config.png" style="margin-top: 15px;"/>';

        $output .= '<h3>We had problems with resetting your CDN account.</h3>';
        $output .= '<p>Please contact our support for further details.</p>';
        wp_send_json_error(array('html' => $output));
      }
    }

    wp_send_json_success(array('html' => $output, 'attachments' => $count, 'found' => ''));
  }


  public function check_cdn_status() {
    // First check if CDN Zone already exists
    $options = get_option(WPS_IC_OPTIONS);

    $request_params           = array();
    $request_params['apiv3']  = 'true';
    $request_params['apikey'] = $options['api_key'];
    $request_params['action'] = 'cdn_check';
    $request_params['url'] = site_url();

    $params = array(
      'method'      => 'POST',
      'timeout'     => 30,
      'redirection' => 3,
      'sslverify'   => false,
      'httpversion' => '1.0',
      'blocking'    => true, // TODO: Mozda true?
      'headers'     => array(),
      'body'        => $request_params,
      'cookies'     => array()
    );

    // Send call to API
    $call = wp_remote_post('http://206.189.251.204/', $params);


    if (wp_remote_retrieve_response_code($call) == 200) {
      $body = wp_remote_retrieve_body($call);
      $body = json_decode($body);

      if ($body->success == 'true') {
        // CDN Does exist or we just created it
        if ($body->data == 'suspended') {
          // CDN Suspended (bandwidth)
          $output = '';
          $output .= '<img src="' . WPS_IC_URI . 'assets/thumbnails-config.png" style="margin-top: 15px;"/>';

          $output .= '<h3>Your CDN account has used all of it\'s bandwidth quota.</h3>';
          $output .= '<p>Please contact our support for further details.</p>';

          wp_send_json_error(array('html' => $output));
        }

      } else {
        // CDN Does not exist,error
        $output = '';
        $output .= '<img src="' . WPS_IC_URI . 'assets/thumbnails-config.png" style="margin-top: 15px;"/>';

        $output .= '<h3>We had problems with creating your CDN account.</h3>';
        $output .= '<p>Please contact our support for further details.</p>';

        wp_send_json_error(array('html' => $output));
      }
    }

    $output .= '<img src="' . WPS_IC_URI . 'assets/thumbnails-config.png" style="margin-top: 15px;"/>';

    $output .= '<h3>Your images are up to date on the CDN</h3>';
    $output .= '<p>Look for significantly faster global performance.</p>';

    wp_send_json_success(array('html' => $output));
  }


  public function resync_cdn() {
    global $wps_ic;

    // First check if CDN Zone already exists
    $call = wp_remote_get(WPS_IC_APIURL . '?cdn_exists=true&domain=' . site_url(), array('timeout' => '10', 'sslverify' => false));
    if (wp_remote_retrieve_response_code($call) == 200) {

      if ( ! empty($_POST['attachments'])) {
        $attachments = $_POST['attachments'];
      } else {
        $attachments = get_posts(array(
                                   'post_type'      => 'attachment',
                                   'posts_per_page' => '-1',
                                   'meta_query'     => array(
                                     array(
                                       'key'   => 'wps_ic_docdn',
                                       'value' => 'true'
                                     )
                                   )
                                 ));
      }
      if ( ! empty($attachments)) {
        foreach ($attachments as $attachment) {

          /*
          $attachmentID = $attachment->ID;
          $thumbs       = $wps_ic->compress->get_all_thumbnails($attachmentID);

          if ( ! empty($_GET['debug'])) {
            var_dump(WPS_IC_APIURL . '?resync_cdn=true&attachmentID=' . $attachmentID . '&images=' . $thumbs);
          }

          $ch = curl_init(WPS_IC_APIURL . '?resync_cdn=true&attachmentID=' . $attachmentID . '&images=' . $thumbs);
          curl_setopt($ch, CURLOPT_USERAGENT, 'api');
          curl_setopt($ch, CURLOPT_TIMEOUT, 1);
          curl_setopt($ch, CURLOPT_HEADER, 0);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
          curl_setopt($ch, CURLOPT_FORBID_REUSE, true);
          curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 1);
          curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 10);
          curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
          curl_exec($ch);
          curl_close($ch);
          */

        }
      }
    } else {
      wp_send_json_error();
    }
  }


  public function resync_cdn_marker() {
    global $wps_ic;
    $attachmentID = sanitize_text_field($_GET['attachmentID']);

    if ( ! empty($attachmentID)) {
      update_post_meta($attachmentID, 'wps_ic_cdn', 'true');
    }
  }


  public function wps_ic_regenerate_thumbs() {
    global $wpdb;
    $regen_count = 0;
    $regen_limit = 1;


    ini_set('max_execution_time', '120');

    if ( ! defined('ABSPATH')) {
      /** Set up WordPress environment */
      require_once(dirname(__FILE__) . '/wp-load.php');
    }

    if ( ! function_exists('wp_generate_attachment_metadata')) {
      require_once ABSPATH . 'wp-admin/includes/image.php';
    }

    if ( ! function_exists('download_url')) {
      require_once(ABSPATH . "wp-admin" . '/includes/image.php');
      require_once(ABSPATH . "wp-admin" . '/includes/file.php');
      require_once(ABSPATH . "wp-admin" . '/includes/media.php');
    }

    if ( ! function_exists('update_option')) {
      require_once(ABSPATH . "wp-includes" . '/option.php');
    }

    $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE status=%s AND type=%s", 'queued', 'regenerate_thumbnail');
    $queue = $wpdb->get_results($queue);

    if ($queue) {
      foreach ($queue as $attachment) {
        $attachment_id = $attachment->attachment_ID;
        $uploadfile    = get_attached_file($attachment_id);
        $attach_data   = wp_generate_attachment_metadata($attachment_id, $uploadfile);
        wp_update_attachment_metadata($attachment_id, $attach_data);

        $delete = $wpdb->prepare("DELETE FROM " . $wpdb->prefix . "ic_queue WHERE attachment_ID=%s AND type=%s", $attachment_id, 'regenerate_thumbnail');
        $delete = $wpdb->query($delete);

        $regen_count ++;

        if ($regen_count >= $regen_limit) {
          wp_send_json_success();
        }

      }
    }

    wp_send_json_error();
  }


  public function wps_ic_setup_rebuild_cron() {
    $ai = new wps_addon_adaptive();
    $ai->setup_rebuild_cron();
    die();
  }


  public function wps_ic_any_thumbnails_to_rebuild() {
    $ai = new wps_addon_adaptive();
    #$ai->any_thumbnails_to_rebuild();
    die();
  }


  public function wps_ic_rebuild_image() {
    $ai = new wps_addon_adaptive();
    $ai->regenerate();
    die('x');
  }


  public function get_reset_images() {
    global $wpdb, $wps_ic;
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';

    $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE status=%s AND type=%s", 'queued', 'reset');
    $queue = $wpdb->get_results($queue);

    if ($queue) {
      $output = array();

      foreach ($queue as $attachment) {

        $attach_id = $attachment->attachment_ID;
        $info      = '';
        $actions   = '';

        $dimmensions        = get_post_meta($attach_id, 'wps_ic_dimmensions', true);
        $uncompressed_value = get_post_meta($attach_id, 'wps_ic_noncompressed_size', true);

        // Image is compressed
        $uncompressed_value = size_format($uncompressed_value, 2);

        $info .= '<div class="wps-ic-uncompressed">';
        $info .= '<img src="' . $logo_uncompressed . '" />';
        $info .= '<h5>Not Compressed</h5>';
        $info .= '</div>';

        $actions .= '<div class="wps-ic-media-actions">';
        $actions .= '<ul class="wps-ic-noncompressed-icon">';
        $actions .= '<li class="wps-ic-weight"><span>' . $uncompressed_value . '</span></li>';
        $actions .= '<li class="wps-ic-size"><span>' . $dimmensions['width'] . 'x' . $dimmensions['height'] . '</span></li>';
        $actions .= '<li class="wps-ic-li-no-padding">';
        $actions .= '<div class="wps-ic-media-actions-toolbox">';
        $actions .= '<ul class="wps-ic-noncompressed-icon">';
        $actions .= '<li class="wps-ic-action">';

        $actions .= '<div class="btn-group">';
        $actions .= '<button type="button" class="btn btn-success wps-ic-compress-single" data-image_id="' . $attach_id . '">Compress</button>';
        $actions .= '<button type="button" class="btn btn-success dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">';
        $actions .= '<span class="caret"></span>';
        $actions .= '<span class="sr-only">Toggle Dropdown</span>';
        $actions .= '</button>';
        $actions .= '<ul class="dropdown-menu">';
        $actions .= apply_filters('wps_ic_pro_exclude', $attach_id);
        $actions .= '</ul>';
        $actions .= '</div>';

        $actions .= '</li>';
        $actions .= '</ul>';
        $actions .= '</div>';

        $output[ $attachment->attachment_ID ]['info']    = $info;
        $output[ $attachment->attachment_ID ]['actions'] = $actions;

        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'restore');
        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'hidden_restore_bulk');

        wp_send_json_success($output);
      }

    } else {
      $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND message=%s", 'restore', '{"code":"restoring"}');
      $queue = $wpdb->get_results($queue);

      if ($queue) {
        wp_send_json_success('restoring');
      } else {
        $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND message=%s", 'restore', '');
        $queue = $wpdb->get_results($queue);

        if ($queue) {
          wp_send_json_success('compressing');
        }
      }
    }

    wp_send_json_error();
  }


  public function get_restored_images() {
    global $wpdb, $wps_ic;
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';

    $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE (status=%s OR status=%s) AND (type=%s OR type=%s)", 'regenerate', 'restored', 'restore', 'hidden_restore_bulk');
    $queue = $wpdb->get_results($queue);

    if ($queue) {
      $output = array();

      foreach ($queue as $attachment) {

        $attach_id = $attachment->attachment_ID;
        $info      = '';
        $actions   = '';

        $dimmensions        = get_post_meta($attach_id, 'wps_ic_dimmensions', true);
        $uncompressed_value = get_post_meta($attach_id, 'wps_ic_noncompressed_size', true);

        if (!$dimmensions) {
          $uploadfile         = get_attached_file($attach_id);
          $imagesize          = getimagesize($uploadfile);
          $dimmensions['width']  = $imagesize[0];
          $dimmensions['height'] = $imagesize[1];
        }

        // Image is compressed
        $uncompressed_value = size_format($uncompressed_value, 2);

        $info .= '<div class="wps-ic-uncompressed">';
        $info .= '<img src="' . $logo_uncompressed . '" />';
        $info .= '<h5>Not Compressed</h5>';
        $info .= '</div>';

        $actions .= '<div class="wps-ic-media-actions">';
        $actions .= '<ul class="wps-ic-noncompressed-icon">';
        $actions .= '<li class="wps-ic-weight"><span>' . $uncompressed_value . '</span></li>';
        $actions .= '<li class="wps-ic-size"><span>' . $dimmensions['width'] . 'x' . $dimmensions['height'] . '</span></li>';
        $actions .= '<li class="wps-ic-li-no-padding">';
        $actions .= '<div class="wps-ic-media-actions-toolbox">';
        $actions .= '<ul class="wps-ic-noncompressed-icon">';
        $actions .= '<li class="wps-ic-action">';

        $actions .= '<div class="btn-group">';
        $actions .= '<button type="button" class="btn btn-success wps-ic-compress-single" data-image_id="' . $attach_id . '">Compress</button>';
        $actions .= '<button type="button" class="btn btn-success dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">';
        $actions .= '<span class="caret"></span>';
        $actions .= '<span class="sr-only">Toggle Dropdown</span>';
        $actions .= '</button>';
        $actions .= '<ul class="dropdown-menu">';
        $actions .= apply_filters('wps_ic_pro_exclude', $attach_id);
        $actions .= '</ul>';
        $actions .= '</div>';

        $actions .= '</li>';
        $actions .= '</ul>';
        $actions .= '</div>';

        $output[ $attachment->attachment_ID ]['info']    = $info;
        $output[ $attachment->attachment_ID ]['actions'] = $actions;

        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'restore');
        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'hidden_restore_bulk');
        #$wps_ic->queue->change_queue_status($attachment->attachment_ID, 'done', 'echoed', '');

        $update = $wpdb->prepare("UPDATE " . $wpdb->prefix . "ic_queue SET status=%s, message=%s WHERE ID=%s", 'done', 'echoed', $attachment->ID);
        $wpdb->query($update);

        wp_send_json_success($output);
      }

    } else {
      $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND message=%s", 'restore', '{"code":"restoring"}');
      $queue = $wpdb->get_results($queue);

      if ($queue) {
        wp_send_json_success('restoring');
      } else {
        $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND message=%s", 'restore', '');
        $queue = $wpdb->get_results($queue);

        if ($queue) {
          wp_send_json_success('compressing');
        }
      }
    }

    wp_send_json_error();
  }


  public function get_queued_images() {
    global $wps_ic;
    $restore_queue  = $wps_ic->queue->get_next_queue('hidden_restore_bulk');
    $compress_queue = $wps_ic->queue->get_next_queue('hidden_compress_bulk');

    if ($restore_queue || $compress_queue) {
      wp_send_json_success();
    } else {
      wp_send_json_error();
    }
  }


  public function get_compressed_images() {
    global $wpdb, $wps_ic;
    $logo_compressed = WPS_IC_URI . 'assets/images/compressed.png';

    $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE status=%s AND (type=%s OR type=%s)", 'compressed', 'compress', 'hidden_compress_bulk');
    $queue = $wpdb->get_results($queue);

    if ($queue) {
      $output = array();

      foreach ($queue as $attachment) {

        $attach_id = $attachment->attachment_ID;
        $info      = '';
        $actions   = '';

        $file_data          = get_attached_file($attach_id);
        $compress           = get_post_meta($attach_id, 'wps_ic_data', true);
        $dimmensions        = get_post_meta($attach_id, 'wps_ic_dimmensions', true);
        $uncompressed_value = get_post_meta($attach_id, 'wps_ic_noncompressed_size', true);

        if ( ! $compress || empty($compress['new']['size'])) {
          continue;
        }

        if (empty($dimmensions)) {
          // Dimensions
          $dimensions = wp_get_attachment_metadata($attach_id);
          update_post_meta($attach_id, 'wps_ic_dimmensions', $dimensions);
        }

        $attachment_dimensions_new = $compress['new']['data']['width'] . 'x' . $compress['new']['data']['height'];

        if ( ! empty($compress) && ! empty($compress['old']['size'])) {
          // Image is compressed
          $compressed_value_num = $compressed_value = $compress['new']['size'];
          $uncompressed_value   = $compress['old']['size'];
        } else {
          // Image is not compressed
          $compressed_value_num = $compressed_value = 0;

          if (empty($uncompressed_value)) {
            $uncompressed_value = filesize($file_data);
            update_post_meta($attach_id, 'wps_ic_noncompressed_size', $uncompressed_value);
          }

        }

        if ($compress != 'not_able') {

          // Old size
          $uncompressed_value_num = $compress['old']['size'] / 1000;

          // Saved total
          $saved_total = $compress['old']['size'] - $compressed_value_num;
          $saved_total = size_format($saved_total, 2);

          // Saved
          $saved = ($compressed_value_num / ($uncompressed_value_num * 1000)) * 100;
          $saved = round(100 - $saved, 0) . '';

          if ($saved == '0') {

            // Not Further Savings
            $info = '';
            $info .= '<div class="wps-ic-uncompressed">';
            $info .= '<img src="' . $logo_compressed . '" />';
            $info .= '<h5 class="no-further-savings">No Further Savings</h5>';
            $info .= '</div>';

          } else {

            // x% saved on compression
            $info = '';
            $info .= '<div class="wps-ic-compressed">';
            $info .= '<img src="' . $logo_compressed . '" />';
            $info .= '<h5>' . $saved . '%</h5>';
            $info .= '<h5>' . $saved_total . '</h5>';
            $info .= '<h5>Saved</h5>';
            $info .= '</div>';

          }

          $actions .= '<div class="wps-ic-media-actions">';
          $actions .= '<div class="wps-ic-half-media-actions">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';

          $actions .= '<li class="wps-ic-weight"><span class="strike">' . size_format($uncompressed_value, 2) . '</span></li>';
          $actions .= '<li class="wps-ic-size"><span>' . $attachment_dimensions_new . '</span></li>';

          $actions .= '</ul>';
          $actions .= '</div>';
          $actions .= '<div class="wps-ic-half-media-actions">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '</li>';

          $actions .= '<li class="wps-ic-size-compressed"><span>' . size_format($compressed_value, 2) . '</span></li>';
          #$actions .= '<li class="wps-ic-time"><span>' . $time . '</span></li>';

          $actions .= '</ul>';
          $actions .= '</div>';

          $actions .= '<div class="wps-ic-media-actions-toolbox">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '<li class="wps-ic-action">';

          $actions .= '<button type="button" class="btn btn-info wps-ic-restore-single" data-image_id="' . $attach_id . '">Restore</button>';

          $actions .= '</li>';
          $actions .= '</ul>';
          $actions .= '</div>';

          $actions .= '</div>';

        } else {
          // Compressed
          $file_data        = get_attached_file($attach_id);
          $compressed_value = filesize($file_data);
          $compressed_value = size_format($compressed_value, 2);
          $dimensions       = getimagesize($file_data);

          $info .= '<div class="wps-ic-compressed">';
          $info .= '<img src="' . $logo_compressed . '" />';
          $info .= '<h5 class="no-further-savings">No Further Savings</h5>';
          $info .= '</div>';

          $actions .= '<div class="wps-ic-media-actions">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '<li class="wps-ic-weight"><span>' . $compressed_value . '</span></li>';
          $actions .= '<li class="wps-ic-size"><span>' . $dimensions[0] . 'x' . $dimensions[1] . '</span></li>';
          $actions .= '<li class="wps-ic-li-no-padding">';
          $actions .= '<div class="wps-ic-media-actions-toolbox">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '<li class="wps-ic-action">';

          $actions .= '<button type="button" class="btn btn-info wps-ic-restore-single" data-type="reset" data-image_id="' . $attach_id . '">Reset</button>';

          $actions .= '</li>';
          $actions .= '</ul>';
          $actions .= '</div>';

          $actions .= '<div id="wps-ic-compare' . $attach_id . '" class="lightbox wp-ic-compare"></div>';
          $actions .= '<div id="wps-ic-pro-compare' . $attach_id . '" class="lightbox wp-ic-compare"></div>';
        }

        $output[ $attachment->attachment_ID ]['info']    = $info;
        $output[ $attachment->attachment_ID ]['actions'] = $actions;

        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'compress');
        #$wps_ic->queue->remove_queue($attachment->attachment_ID, false, 'hidden_compress_bulk');

        $update = $wpdb->prepare("UPDATE " . $wpdb->prefix . "ic_queue SET status=%s, message=%s WHERE ID=%s", 'done', 'echoed', $attachment->ID);
        $wpdb->query($update);
      }

      $cache = $wpdb->query("DELETE FROM " . $wpdb->postmeta . " WHERE meta_key='_ic_sources' OR meta_key='_ic_cdn_content'");

      wp_send_json_success($output);
    } else {

      $queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE status=%s AND type=%s", 'queued', 'compress');
      $queue = $wpdb->get_results($queue);

      if ($queue) {
        wp_send_json_success('compressing');
      } else {
        /*$queue = $wpdb->prepare("SELECT * FROM " . $wpdb->prefix . "ic_queue WHERE status=%s AND type=%s", 'queued', 'compress');
        $queue = $wpdb->get_results($queue);

        if ($queue) {
          wp_send_json_success('compressing');
        }*/
      }

    }

    wp_send_json_error();
  }


  public function add_ajax($hook) {
    add_action('wp_ajax_' . $hook, array($this, $hook));
  }


  public function wps_ic_get_thumbnail_checkboxes() {
    global $wps_ic;

    $output = '';

    $settings = $wps_ic->options->get_settings();

    $sizes       = get_intermediate_image_sizes();
    $all_checked = 1;
    foreach ($sizes as $key => $value) {
      if (checked('1', $settings['thumbnails'][ $value ], false) != " checked='checked'") {
        $all_checked = 0;
      }
    }

    foreach ($sizes as $key => $value) {

      if ($settings['thumbnails'][ $value ] == '1') {
        $output .= '<div class="checkbox-container popup-checkbox wp-ic-setting[thumbnails][' . $value . ']">
          <h3> ' . $value . '</h3>
          <div>
            <input type="checkbox" class="checkbox" id="wp-ic-setting[thumbnails][' . $value . ']" style="display: none;" ' . checked('1', $settings['thumbnails'][ $value ], false) . ' value="' . $value . '"
                   name="wp-ic-setting[thumbnails][' . $value . ']"/>
            <label for="wp-ic-setting[thumbnails][' . $value . ']" class="check checkbox-live">
              <svg width="18px" height="18px" viewBox="0 0 18 18">
                <path d="M1,9 L1,3.5 C1,2 2,1 3.5,1 L14.5,1 C16,1 17,2 17,3.5 L17,14.5 C17,16 16,17 14.5,17 L3.5,17 C2,17 1,16 1,14.5 L1,9 Z"></path>
                <polyline points="1 9 7 14 15 4"></polyline>
              </svg>
            </label>
          </div>
        </div>';
      } else {
        $output .= '<div class="checkbox-container popup-checkbox popup-deactivated wp-ic-setting[thumbnails][' . $value . ']">
          <h3> ' . $value . '</h3>
          <div>
            <input type="checkbox" class="checkbox" id="wp-ic-setting[thumbnails][' . $value . ']" style="display: none;" ' . checked('1', $settings['thumbnails'][ $value ], false) . ' value="' . $value . '"
                   name="wp-ic-setting[thumbnails][' . $value . ']"/>
            <label for="wp-ic-setting[thumbnails][' . $value . ']" class="check checkbox-live">
              <svg width="18px" height="18px" viewBox="0 0 18 18">
                <path d="M1,9 L1,3.5 C1,2 2,1 3.5,1 L14.5,1 C16,1 17,2 17,3.5 L17,14.5 C17,16 16,17 14.5,17 L3.5,17 C2,17 1,16 1,14.5 L1,9 Z"></path>
                <polyline points="1 9 7 14 15 4"></polyline>
              </svg>
            </label>
          </div>
        </div>';
      }
    }

    $output .= '<div class="clearfix"></div>
        <div style="height: 30px"></div>
        <a href="#" class="popup-save" data-action="thumbnails">Save</a>';

    wp_send_json_success(array('html' => $output));
  }


  /**
   * Compress Heartbeat
   */
  public
  function compress_heartbeat() {
    global $wps_ic;

    $default                   = array();
    $default['compress_queue'] = '';
    $default['restore_queue']  = '';

    // Change memory limits
    $wps_ic->change_limits();

    $compress_queue = $wps_ic->queue->get_compress_queue();
    $restore_queue  = $wps_ic->queue->get_restore_queue();

    // Cron do compress
    if ( ! empty($compress_queue)) {
      $default['compress_queue'] = $compress_queue;
      wp_send_json_success($default);
    }

    // Cron do restore
    if ( ! empty($restore_queue)) {
      $default['restore_queue'] = $restore_queue;
      wp_send_json_success($default);
    }

    // Reset locked images
    global $wpdb;
    $attachments = $wpdb->get_results("SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_type='attachment' AND post_status='inherit' ORDER BY post_date DESC");

    if ($attachments) {
      foreach ($attachments as $attachment) {
        $compress   = get_post_meta($attachment->ID, 'wps_ic_data', true);
        $in_process = get_post_meta($attachment->ID, 'wps_ic_in_bulk', true);

        if ($in_process == 'true') {
          delete_post_meta($attachment->ID, 'wps_ic_data');
          delete_post_meta($attachment->ID, 'wps_ic_cdn');
          delete_post_meta($attachment->ID, 'wps_ic_exclude');
          delete_post_meta($attachment->ID, 'wps_ic_in_bulk');
        }

      }
    }

    wp_send_json_error($default);
  }


  /**
   * BACKGROUND Process Image
   */
  public
  function wps_ic_compress_background_cron() {
    global $wps_ic;

    $logo_compressed   = WPS_IC_URI . 'assets/images/compressed.png';
    $logo_uncompressed = WPS_IC_URI . 'assets/images/not-compressed.png';
    $logo_excluded     = WPS_IC_URI . 'assets/images/excluded.png';

    $response         = array();
    $compressed_items = get_option('wps_ic_compressed');

    if ( ! empty($compressed_items)) {

      if ( ! empty($compressed_items['waiting'])) {
        foreach ($compressed_items['waiting'] as $key => $attachment_ID) {

          // Saved meta data
          $meta = get_post_meta($attachment_ID, 'wps_ic_data', true);

          $time = get_post_meta($attachment_ID, 'wps_ic_times', true);

          $client   = ($time['client_ended'] - $time['client_started']);
          $compress = ($time['compress_ended'] - $time['compress_started']);
          $time     = number_format($client + $compress, 1) . 's';

          // Compressed
          $file_data            = get_attached_file($attachment_ID);
          $compressed_value_num = $compressed_value = filesize($file_data);
          $compressed_value     = size_format($compressed_value, 2);

          // Old size
          $uncompressed_value_num = $meta['old']['size'] / 1000;
          $uncompressed_value     = size_format($meta['old']['size'], 2);

          // Saved total
          $saved_total = $meta['old']['size'] - $compressed_value_num;
          $saved_total = size_format($saved_total, 2);

          // Saved
          $saved = ($compressed_value_num / ($uncompressed_value_num * 1000)) * 100;
          $saved = round(100 - $saved, 0) . '%';

          // Dimensions
          /*if (empty($meta['old']['data']['width'])) {
            $attachment_dimensions_new = 'Unreadable';
          } else {*/
          $attachment_dimensions_new = $meta['new']['data']['width'] . 'x' . $meta['new']['data']['height'];
          /*}*/

          $output = '';
          $output .= '<div class="wps-ic-compressed">';
          $output .= '<img src="' . $logo_compressed . '" />';
          $output .= '<h5>' . $saved . '</h5>';
          $output .= '<h5>' . $saved_total . '</h5>';
          $output .= '<h5>Saved</h5>';
          $output .= '</div>';

          $actions = '';

          $actions .= '<div class="wps-ic-media-actions">';
          $actions .= '<div class="wps-ic-half-media-actions">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';

          $actions .= '<li class="wps-ic-weight"><span class="strike">' . $uncompressed_value . '</span></li>';
          $actions .= '<li class="wps-ic-size"><span>' . $attachment_dimensions_new . '</span></li>';

          $actions .= '</ul>';
          $actions .= '</div>';
          $actions .= '<div class="wps-ic-half-media-actions">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '</li>';

          $actions .= '<li class="wps-ic-size-compressed"><span>' . $compressed_value . '</span></li>';
          #$actions .= '<li class="wps-ic-time"><span>' . $time . '</span></li>';

          $actions .= '</ul>';
          $actions .= '</div>';

          $actions .= '<div class="wps-ic-media-actions-toolbox">';
          $actions .= '<ul class="wps-ic-noncompressed-icon">';
          $actions .= '<li class="wps-ic-action">';

          $actions .= '<button type="button" class="btn btn-info wps-ic-restore-single" data-image_id="' . $attachment_ID . '">Restore</button>';

          $actions .= '</li>';
          $actions .= '</ul>';
          $actions .= '</div>';

          $actions .= '</div>';

          $response[ $attachment_ID ]['output']  = $output;
          $response[ $attachment_ID ]['actions'] = $actions;

          unset($compressed_items['waiting'][ $key ]);
          update_option('wps_ic_compressed', $compressed_items);
        }
        wp_send_json_success($response);
      }
    }
    wp_send_json_error();
  }


  /**
   * @since 3.3.0
   */
  public
  static function wps_ic_api_check_credits() {
    // Check credits
    $options       = get_option(WPS_IC_OPTIONS);
    $check_credits = wp_remote_get(WPS_IC_APIURL . '?apikey=' . $options['api_key'] . '&check_credits=true', array('timeout' => '25', 'sslverify' => false));
    $credits       = 0;

    if (wp_remote_retrieve_response_code($check_credits) == 200) {
      $body = wp_remote_retrieve_body($check_credits);
      $body = json_decode($body, true);
    }

    wp_send_json_success($body['data']['credits']);
  }


  /**
   * @since 3.3.0
   */
  public function wps_ic_wake_up_cron($response = true) {
    $working = get_transient('ic_cron_working');

    if ( ! empty($working) && $working == 'true') {
      wp_send_json_success();
    }

    foreach (_get_cron_array() as $timestamp => $events) {

      foreach ($events as $event_hook => $event_args) {
        foreach ($event_args as $event) {

          if ($event_hook == 'wps_ic_regen_thumbs_by_array') {
            foreach ($event_args as $hash => $event_Args) {

              if ( ! empty($event_Args['args'])) {
                delete_transient('doing_cron');
                set_transient('ic_cron_working', 'true', 20);
                do_action_ref_array($event_hook, $event_Args['args']);
              }

              wp_send_json_success('regen_thumbs');
            }
          }

          if ($event_hook == 'wps_ic_compress_single') {
            foreach ($event_args as $hash => $event_Args) {

              if ( ! empty($event_Args['args'])) {
                delete_transient('doing_cron');
                set_transient('ic_cron_working', 'true', 20);
                do_action_ref_array($event_hook, $event_Args['args']);
              }

              wp_send_json_success('compress');
            }
          }

          if ($event_hook == 'wps_ic_restore_single') {
            foreach ($event_args as $hash => $event_Args) {

              if ( ! empty($event_Args['args'])) {
                delete_transient('doing_cron');
                #set_transient('ic_cron_working', 'true', 6);
                do_action_ref_array($event_hook, $event_Args['args']);
              }

              wp_send_json_success('restore');
            }
          }

        }

      }

    }

    if ($response) {
      wp_send_json_success();
    } else {
      update_option('no_cron_set', 'true');
      wp_send_json_error();
    }
  }


  /**
   * @since 3.3.0
   */
  public
  function wps_ic_restore_single() {
    global $wps_ic;
    update_option('wps_ic_restore_queue_status', array('ID' => $_POST['ID'], 'status' => 'working'));
    $wps_ic->compress->hidden_restore($_POST['ID']);
    wp_send_json_success();
  }


  /**
   * @since 3.3.0
   */
  public function wps_ic_restore_hidden_bulk($response = true) {
    global $wps_ic, $wpdb;
    update_option('wps_ic_hidden_bulk_running', 'true');

    $queue = $wps_ic->queue->get_queue('hidden_restore_bulk');

    $attachments  = array();
    $queued       = 0;
    $delay        = 0;
    $total_queued = 0;

    if ($queue) {

      wp_send_json_success(array('total_queued' => count($queue)));

    }

    if ($response) {
      wp_send_json_success(array('total_queued' => count($queue)));
    }
  }


  /**
   * @since 4.0.3
   */
  public function wps_ic_compress_fetch_thumbnails() {
    global $wps_ic, $wpdb;
    $apikey = $wps_ic::$api_key;

    return;

    $attachments = $_POST['attachments'];
    if (empty($attachments)) {
      wp_send_json_error();
    }

    $request_params                = array();
    $request_params['apiv3']       = 'true';
    $request_params['bulk']        = 'true';
    $request_params['apikey']      = $apikey;
    $request_params['action']      = 'fetch_thumbnails';
    $request_params['url']         = site_url();
    $request_params['attachments'] = json_encode($attachments);

    $params = array(
      'method'      => 'POST',
      'timeout'     => 30,
      'redirection' => 3,
      'sslverify'   => false,
      'httpversion' => '1.0',
      'blocking'    => true, // TODO: Mozda true?
      'headers'     => array(),
      'body'        => $request_params,
      'cookies'     => array()
    );

    // Send call to API
    $call = wp_remote_post('http://206.189.251.204/', $params);

    var_dump(wp_remote_retrieve_body($call));
    wp_send_json_success();

    if (wp_remote_retrieve_response_code($call) == 200) {
      $body        = wp_remote_retrieve_body($call);
      $body        = json_decode($body, true);
      $attachments = $body['data'];

      if ( ! empty($attachments)) {
        foreach ($attachments as $attachment_ID => $data) {
          $wps_ic->compress->update_image($attachment_ID, $data);
        }
      }

    }

    wp_send_json_success();
  }


  /**
   * @since 4.0.3
   */
  public function wps_ic_compress_next_in_queue() {
    global $wps_ic, $wpdb;

    ini_set('max_execution_time', '120');

    $restore_queue  = $wps_ic->queue->get_next_queue('hidden_restore_bulk');
    $compress_queue = $wps_ic->queue->get_next_queue('hidden_compress_bulk');

    if ($restore_queue) {
      $fetch = $wpdb->prepare("SELECT attachment_ID, type, status FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND status=%s ORDER BY attachment_ID DESC LIMIT 3", 'hidden_restore_bulk', 'queued');
      $items = $wpdb->get_results($fetch);

      $compress_queue = array();
      if ($items) {
        foreach ($items as $item) {
          $compress_queue[] = $item->attachment_ID;
        }

        #$wps_ic->compress->hidden_restore($item->attachment_ID);
        $wps_ic->compress->bulk_restore(array('attachments' => $compress_queue));
        wp_send_json_success(array('action' => 'restore', 'done' => $compress_queue, 'attachments' => $compress_queue));
      }
    }

    if ($compress_queue) {
      $fetch = $wpdb->prepare("SELECT attachment_ID, type, status FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND status=%s ORDER BY attachment_ID DESC LIMIT 3", 'hidden_compress_bulk', 'queued');
      $items = $wpdb->get_results($fetch);

      $compress_queue = array();
      if ($items) {
        foreach ($items as $item) {
          $compress_queue[] = $item->attachment_ID;
        }

        $wps_ic->compress->bulk(array('attachments' => $compress_queue));
        wp_send_json_success(array('action' => 'compress', 'done' => $compress_queue, 'attachments' => $compress_queue));
      }

    }

    wp_send_json_error();
  }


  /**
   * @since 3.3.0
   */
  public function wps_ic_get_queue() {
    global $wps_ic, $wpdb;

    #$transient = get_transient('wps_ic_compress_info');

    $restore_queue  = $wps_ic->queue->get_next_queue('hidden_restore_bulk');
    $compress_queue = $wps_ic->queue->get_next_queue('hidden_compress_bulk');
    $no_cron_set    = get_option('no_cron_set');

    if ($restore_queue || $compress_queue) {

      $wps_ic->log->write_log('0', 'Get Queue');
      $queue = $wps_ic->compress->get_queue();

      if ($restore_queue) {
        $queue_type = 'hidden_restore_bulk';
      } else if ($compress_queue) {
        $queue_type = 'hidden_compress_bulk';
      }

      $queue_done = $wps_ic->queue->get_done_queue($queue_type);

      if ($queue_done >= $queue['queue']) {
        $queue_transient = get_option('wps_ic_compress_info');

        delete_option('wps_ic_hidden_bulk_running');
        delete_option('wps_ic_compress_info');

        $started = get_option('wps_ic_bulk_started');
        $end     = microtime(true);
        update_option('wps_ic_bulk_ended', $end);

        wp_send_json_error(array('error' => 'queue done >= queue', 'action' => $queue_transient['action'], 'queue_done' => $queue_done, 'queue' => $queue['queue'], 'cron_set' => $no_cron_set, 'time' => ($end - $started)));
      }

      if ($no_cron_set == 'true') {

        // Prepare query
        $attachments = array();
        $fetch       = $wpdb->prepare("SELECT attachment_ID, type, status FROM " . $wpdb->prefix . "ic_queue WHERE type=%s AND status=%s AND in_cron=%s ORDER BY attachment_ID DESC", $queue_type, 'queued', '0');
        $fetch       = $wpdb->get_results($fetch);

        if ($fetch) {
          foreach ($fetch as $item) {
            $attachments[] = $item->attachment_ID;
          }
        }

        // Check for attachments already in cron
        if ( ! empty($queue) && $queue['total'] > 0) {
          wp_send_json_success(array(
                                 'cron_set' => $no_cron_set,
                                 'total'    => $queue['total'],
                                 'queue'    => $queue['queue'],
                                 'done'     => $queue['done'],
                                 'action'   => $queue['action']
                               ));
        }

        if (empty($attachments) || count($attachments) == 0) {
          $queue_transient = get_option('wps_ic_compress_info');
          delete_option('wps_ic_hidden_bulk_running');
          delete_option('wps_ic_compress_info');
          wp_send_json_error(array('error' => 'empty attachments', 'action' => $queue_transient['action'], 'queue_done' => $queue['done'], 'queue' => $queue['queue'], 'cron_set' => $no_cron_set));
        }

      }

      wp_send_json_success(array(
                             'cron_set'          => $no_cron_set,
                             'attachments_array' => $attachments,
                             'total'             => $queue['total'],
                             'queue'             => $queue['queue'],
                             'done'              => $queue['done'],
                             'action'            => $queue['action']
                           ));
    } else {
      $queue_transient = get_option('wps_ic_compress_info');
      delete_option('wps_ic_hidden_bulk_running');
      delete_option('wps_ic_compress_info');

      $started = get_option('wps_ic_bulk_started');
      $end     = microtime(true);
      update_option('wps_ic_bulk_ended', $end);

      wp_send_json_error(array('action' => $queue_transient['action'], 'time' => 'Bulk total time ' . ($end - $started) . ' seconds'));
    }
  }


  /**
   * Exclude the image
   * @since 3.3.0
   */
  public
  function wps_ic_exclude_image() {
    global $wps_ic;
    do_action('ic_debug', $_POST['attachment_id'], 'Triggered Exclude');
    $wps_ic->compress->exclude($_POST, 'html');
  }


  /**
   * Verify user has membership active?
   */
  public
  function membership() {
    global $wps_ic;

    $package = get_transient('wps_ic_membership');

    if (empty($package)) {

      // Setup URI
      $uri = WPS_IC_KEYSURL;
      $uri .= '?action=membership';
      $uri .= '&apikey=' . $wps_ic::$api_key;
      $uri .= '&site=' . urlencode(site_url());

      // Verify API Key is our database and user has is confirmed getresponse
      $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

      if (wp_remote_retrieve_response_code($get) == 200) {
        $body = wp_remote_retrieve_body($get);
        $body = json_decode($body);

        if ($body->success == true && $body->data != 'false') {
          return ucfirst($body->data);
        }

        return false;
      }

      return false;

    } else {
      return true;
    }
  }


  /**
   * Verify Orp With API
   */
  public
  function wps_ic_orp() {
    global $wps_ic;

    $package = get_transient('wps_ic_pro');

    if (empty($package)) {


      // Setup URI
      $uri = WPS_IC_KEYSURL;
      $uri .= '?action=orp';
      $uri .= '&apikey=' . $wps_ic::$api_key;
      $uri .= '&site=' . urlencode(site_url());

      // Verify API Key is our database and user has is confirmed getresponse
      $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

      if (wp_remote_retrieve_response_code($get) == 200) {
        $body = wp_remote_retrieve_body($get);
        $body = json_decode($body);
        if ($body->success == true) {
          return $body->data;
        }

        return false;
      }

      return false;

    } else {
      return true;
    }
  }


  /**
   * Check Quota
   */
  public
  function wps_ic_api_referrals() {
    global $wps_ic;

    $referrals = get_transient('wps_ic_referrals');

    if (empty($referrals) || ! $referrals) {

      // API Key
      $apikey = parent::$api_key;

      // Setup URI
      $uri = WPS_IC_KEYSURL;
      $uri .= '?action=referrals';
      $uri .= '&apikey=' . $apikey;
      $uri .= '&site=' . urlencode(site_url());

      // Verify API Key is our database and user has is confirmed getresponse
      $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

      if (wp_remote_retrieve_response_code($get) == 200) {
        $body = wp_remote_retrieve_body($get);
        $body = json_decode($body);

        if ( ! empty($body->success)) {
          if ($body->success == true && ! empty($body->data)) {
            if ( ! empty($body->data->refID)) {
              set_transient('wps_ic_referrals', $body->data, 60 * 5);

              return $body->data;
            } else {
              $body                    = array();
              $body['total_referrals'] = '0';
              $body['refID']           = '';
              set_transient('wps_ic_referrals', '0', 60 * 5);

              return (object)$body;
            }
          }
        } else {
          $body                    = array();
          $body['total_referrals'] = '0';
          $body['refID']           = '';

          set_transient('wps_ic_referrals', '0', 60 * 5);

          return (object)$body;
        }

        return '0';
      }

      return 'Invalid API Key';

    } else {
      return $referrals;
    }
  }


  /**
   * Check Credits
   */
  public
  function wps_ic_api_credits() {
    global $wps_ic;

    // API Key
    $apikey = $wps_ic::$api_key;

    // Setup URI
    $uri = WPS_IC_KEYSURL;
    $uri .= '?action=get_credits';
    $uri .= '&apikey=' . $apikey;
    $uri .= '&site=' . urlencode(site_url());

    // Verify API Key is our database and user has is confirmed getresponse
    $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

    if (wp_remote_retrieve_response_code($get) == 200) {
      $body = wp_remote_retrieve_body($get);
      $body = json_decode($body);

      if ($body->success == true && ! empty($body->data)) {
        if (empty($body->data->credits)) {
          return '0';
        } else {
          return $body->data->credits;
        }
      }

      return '0';
    }

    return 'Invalid API Key';
  }


  /**
   * Connect Multsites With API
   */
  public
  function wps_ic_api_mu_connect() {
    global $wps_ic;

    // Is localhost?
    $whitelist = array('127.0.0.1', '::1');
    if (in_array($_SERVER['REMOTE_ADDR'], $whitelist)) {
      #wp_send_json_error(array('msg' => 'Sorry, localhost installs are not supported.'));
    }

    $sites = get_sites();

    // API Key
    $apikey         = sanitize_text_field($_POST['apikey']);
    $affiliate_code = get_option('wps_ic_affiliate_code');

    if ($sites && is_multisite()) {
      $error = false;

      foreach ($sites as $key => $site) {

        // Setup URI
        $uri = WPS_IC_KEYSURL;
        $uri .= '?action=connect';
        $uri .= '&apikey=' . $apikey;
        $uri .= '&site=' . urlencode($site->domain . $site->path);
        $uri .= '&affiliate_code=' . $affiliate_code;

        // Verify API Key is our database and user has is confirmed getresponse
        $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

        if (wp_remote_retrieve_response_code($get) == 200) {
          $body = wp_remote_retrieve_body($get);
          $body = json_decode($body);

          if ($body->success == true && $body->data->api_key != '' && $body->data->response_key != '') {
            $wps_ic->options->set_option('api_key', $body->data->api_key);
            $wps_ic->options->set_option('response_key', $body->data->response_key);
            $wps_ic->options->set_option('orp', $body->data->orp);

            $settings = get_option(WPS_IC_SETTINGS);

            $sizes = get_intermediate_image_sizes();
            foreach ($sizes as $key => $value) {
              $settings['thumbnails'][ $value ] = 1;
            }

            update_option(WPS_IC_SETTINGS, $settings);

            //delete_option('wps_ic_affiliate_code');
          }
        } else {
          $error = true;
        }

      }

      if ($error == true) {
        wp_send_json_error($body->data);
      } else {
        wp_send_json_success();
      }

    }

    wp_send_json_error('0');
  }


  /**
   * API Tests
   */
  public
  function wps_ic_api_test() {
    global $wps_ic;
    $wps_ic = new wps_ic();

    $test = sanitize_text_field($_POST['test_id']);

    $wps_ic->tests->call_test($test);
  }


  /**
   * Connect With API
   */
  public
  function wps_ic_api_connect() {
    global $wps_ic;

    delete_option('wps_ic_test');

    // Is localhost?
    $whitelist = array('127.0.0.1', '::1');
    if (in_array($_SERVER['REMOTE_ADDR'], $whitelist)) {
      #wp_send_json_error(array('msg' => 'Sorry, localhost installs are not supported.'));
    }

    // API Key
    $apikey         = sanitize_text_field($_POST['apikey']);
    $affiliate_code = get_option('wps_ic_affiliate_code');

    // Setup URI
    $uri = WPS_IC_KEYSURL;
    $uri .= '?action=connect';
    $uri .= '&apikey=' . $apikey;
    $uri .= '&site=' . urlencode(site_url());
    $uri .= '&affiliate_code=' . $affiliate_code;

    // Verify API Key is our database and user has is confirmed getresponse
    $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

    if (wp_remote_retrieve_response_code($get) == 200) {
      $body = wp_remote_retrieve_body($get);
      $body = json_decode($body);

      if ($body->success == true && $body->data->api_key != '' && $body->data->response_key != '') {
        $wps_ic->options->set_option('api_key', $body->data->api_key);
        $wps_ic->options->set_option('response_key', $body->data->response_key);
        $wps_ic->options->set_option('orp', $body->data->orp);

        // First check if CDN Zone already exists
        $call = wp_remote_get(WPS_IC_APIURL . '?cdn_exists=true&domain=' . site_url(), array('timeout' => '10', 'sslverify' => false));
        if (wp_remote_retrieve_response_code($call) == 200) {
          $cdn_body = wp_remote_retrieve_body($call);
          $cdn_body = json_decode($cdn_body);

          if ($cdn_body->success == 'true') {
            // CDN Does exist or we just created it
          } else {
            // CDN Does not exist,error
          }
        }

        $settings = get_option(WPS_IC_SETTINGS);

        $sizes = get_intermediate_image_sizes();
        foreach ($sizes as $key => $value) {
          $settings['thumbnails'][ $value ] = 1;
        }

        update_option(WPS_IC_SETTINGS, $settings);

        //delete_option('wps_ic_affiliate_code');
        wp_send_json_success();
      }

      wp_send_json_error($body->data);
    }

    wp_send_json_error('0');
  }


  /**
   * Signup to API
   */
  public
  function wps_ic_api_signup() {
    global $wps_ic;

    // Sanitize
    $email = sanitize_email($_POST['email']);
    #$name  = sanitize_text_field($_POST['name']);
    $name           = '';
    $affiliate_code = sanitize_text_field($_POST['affiliate_code']);
    update_option('wps_ic_affiliate_code', $affiliate_code);

    // Is valid email
    if ( ! is_email($email)) {
      wp_send_json_error(array('code' => 100, 'msg' => 'Invalid e-mail!'));
    }

    $uri = WPS_IC_KEYSURL;
    $uri .= '?action=signup';
    $uri .= '&email=' . $email;
    $uri .= '&name=' . $name;
    $uri .= '&site=' . urlencode(site_url());

    $get = wp_remote_get($uri, array('timeout' => 25, 'sslverify' => false));

    if (wp_remote_retrieve_response_code($get) == 200) {
      $body = wp_remote_retrieve_body($get);
      $body = json_decode($body);

      if ($body->success == true) {

        $response      = $body->data->code;
        $referral_code = $body->data->referral_code;

        if ( ! empty($referral_code)) {
          update_option('wps_ic_ref_id', $referral_code);
        }

        if ($response == 110) {
          // Already subscribed and confirmed
          wp_send_json_error(array('code' => 110, 'msg' => 'You are already subscribed!<br/><a href="https://wpcompress.com/lost-api-key/" target="_blank">Retrieve API Key</a>'));
        } else {
          if ($response == 100) {
            // Subscribed but not confirmed
            wp_send_json_success(array('code' => 100, 'msg' => 'We’ve sent your API key to your email - please copy it and confirm!'));
          } else {
            if ($response == 111) {
              // Subscribed but was not in our database
              wp_send_json_error(array('code' => 111, 'msg' => 'You are already subscribed, but you were not found in our database!'));
            } else {
              if ($response == 200) {
                // Subscribed, waiting for confirmation
                wp_send_json_success(array('code' => 200, 'msg' => 'Thanks! Sent confirmation!'));
              } else {
                if ($response == 202) {
                  // Subscribed, waiting for confirmation
                  wp_send_json_error(array('code' => 202, 'msg' => 'You are already subscribed and confirmed!<br/><a href="https://wpcompress.com/lost-api-key/" target="_blank">Retrieve API Key</a>'));
                } else {
                  // Subscribed, waiting for confirmation
                  wp_send_json_error(array('code' => 202, 'msg' => 'Unkown error occured!'));
                }
              }
            }
          }
        }

      }

      // Uknown Error
      wp_send_json_error(array('code' => 0));
    }

    wp_send_json_error(array('code' => wp_remote_retrieve_response_code($get), 'body' => wp_remote_retrieve_body($get)));
  }


  /**
   * Get settings
   */
  public
  function wps_ic_get_setting() {
    global $wps_ic;
    $what     = sanitize_text_field($_POST['what']);
    $settings = $wps_ic->options->get_settings();

    wp_send_json_success($settings[ $what ]);
  }


  /**
   * Change Settings Value
   */
  public
  function wps_ic_settings_change() {
    global $wps_ic;

    $what     = sanitize_text_field($_POST['what']);
    $value    = sanitize_text_field($_POST['value']);
    $checked  = sanitize_text_field($_POST['checked']);
    $checkbox = sanitize_text_field($_POST['checkbox']);

    $settings = $wps_ic->options->get_settings();

    if ($what == 'thumbnails') {

      if ( ! isset($value) || empty($value)) {
        $settings['thumbnails'] = array();
      } else {
        $settings['thumbnails'] = array();
        $value                  = rtrim($value, ',');
        $value                  = explode(',', $value);
        foreach ($value as $i => $thumb_size) {
          $settings['thumbnails'][ $thumb_size ] = 1;
        }

      }

    } else {

      if ($what == 'autopilot') {
        if ($checked == 'checked') {

        } else {
          $settings['otto'] = 'automated';
        }
      }

      if ($checkbox == 'true') {
        if ($checked === 'false') {
          $settings[ $what ] = 0;
        } else {
          $settings[ $what ] = 1;
        }
      } else {
        $settings[ $what ] = $value;
      }
    }

    if ($what == 'generate_webp' || $what == 'adaptive_images' || $what == 'cdn') {
      global $wpdb;
      $cache = $wpdb->query("DELETE FROM " . $wpdb->postmeta . " WHERE meta_key='_ic_sources' OR meta_key='_ic_cdn_content'");

      $attachments = $wpdb->get_results("SELECT ID FROM " . $wpdb->posts . " WHERE post_type='attachment' AND post_status='inherit'");

      $queued       = 0;
      $total_queued = 0;
      $regen_array  = array();
      $delay        = 0;
      if ($attachments) {
        foreach ($attachments as $attachment) {

          $delay += 25;

          $compressed = get_post_meta($attachment->ID, 'wps_ic_data', true);
          if ( ! $compressed || $compressed == 'not_able') {
            continue;
          }

          $queued ++;
          $total_queued ++;

          $regen_array[] = $attachment->ID;

          if ($queued >= 3) {
            wp_schedule_single_event(time(), 'wps_ic_regen_thumbs_by_array', array('attachments' => $regen_array));

            $regen_array = array();
            $queued      = 0;
          }
        }

        if ($queued <= 3) {
          if ( ! empty($regen_array) && count($regen_array) > 0) {
            wp_schedule_single_event(time(), 'wps_ic_regen_thumbs_by_array', array('attachments' => $regen_array));
          }
        }
      }
    }

    update_option(WPS_IC_SETTINGS, $settings);

    wp_send_json_success();
  }


  /**
   * Change Notify Setting Value
   */
  public
  function wps_ic_notify() {
    global $wps_ic;

    $checkbox = 'true';
    $checked  = sanitize_text_field($_POST['checked']);

    $settings = $wps_ic->options->get_settings();

    if ($checked === 'false') {
      $settings['notify'] = 0;
    } else {
      $settings['notify'] = 1;
    }

    update_option(WPS_IC_SETTINGS, $settings);

    wp_send_json_success();
  }


  /**
   * @since 3.3.0
   */
  public function wps_ic_compress_hidden_bulk($response = true) {
    global $wps_ic, $wpdb;
    update_option('wps_ic_hidden_bulk_running', 'true');

    $queue = $wps_ic->queue->get_queue('hidden_compress_bulk');

    $attachments  = array();
    $queued       = 0;
    $total_queued = 0;

    if ($queue) {
      wp_send_json_success(array('total_queued' => count($queue)));
    }

    if ($response) {
      wp_send_json_success(array('total_queued' => count($queue)));
    }
  }


  /**
   * Bulk Restore Hidden Prepare
   */
  public function wps_ic_restore_bulk_prep_background_hidden($response = 'json') {
    global $wps_ic, $wpdb;

    $output = array();

    $count_files = 0;

    update_option('wps_ic_hidden_bulk_running', 'true');
    delete_option(WPS_IC_BULK_RESTORE_TOTAL);
    delete_option(WPS_IC_BULK_RESTORE_PROCESSED);

    // Clear whole queue
    $wps_ic->queue->clear_queue('hidden_compress_bulk');
    $wps_ic->queue->clear_queue('compress_bulk');
    $wps_ic->queue->clear_queue('restore_bulk');
    $wps_ic->queue->clear_queue('hidden_restore_bulk');
    $wps_ic->queue->clear_queue('generate_thumbnail');

    /*
     * Check if it's a single file clicked or bulk compress button
     */
    $attachments = $wpdb->get_results("SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_type='attachment' AND post_status='inherit' ORDER BY post_date DESC");

    if ($attachments) {
      foreach ($attachments as $attachment) {

        $data = get_post_meta($attachment->ID, 'wps_ic_data', true);

        if ($data == 'not_able') {
          update_post_meta($attachment->ID, 'wps_ic_reset', 'true');
          $wps_ic->log->write_log($attachment->ID, 'Reset set to true', '0', 'restore');
        } else {

          // If not compressed skip
          $compressed = get_post_meta($attachment->ID, 'wps_ic_compressed', true);
          if (empty($compressed) && (empty($data) || $data != 'not_able')) {

            // Delete compress data
            delete_post_meta($attachment->ID, 'wps_ic_compressed_size');
            delete_post_meta($attachment->ID, 'wps_ic_reset');
            delete_post_meta($attachment->ID, 'wps_ic_times');
            delete_post_meta($attachment->ID, 'wps_ic_compressed');
            delete_post_meta($attachment->ID, 'wps_ic_data');
            delete_post_meta($attachment->ID, 'wps_ic_cdn');
            delete_post_meta($attachment->ID, 'wps_ic_in_bulk');
            delete_post_meta($attachment->ID, 'wps_ic_compressing');
            delete_post_meta($attachment->ID, 'wps_ic_restoring');

            $wps_ic->log->write_log($attachment->ID, 'Not Compressed ' . $compressed, '0', 'restore');
            continue;
          }

          // If excluded skip
          $excluded = get_post_meta($attachment->ID, 'wps_ic_exclude', true);
          if ( ! empty($excluded) && $excluded == 'true') {
            $wps_ic->log->write_log($attachment->ID, 'Excluded', '0', 'excluded');
            continue;
          }

          // If not compressed skip
          if (empty($data) && empty($data['new'])) {
            $wps_ic->log->write_log($attachment->ID, 'IC data empty', '0', 'restore');
            continue;
          }

        }

        // Allowed type
        $file_data = get_attached_file($attachment->ID);
        $type      = wp_check_filetype($file_data);
        $exif      = exif_imagetype($file_data);

        $allowed_types         = array();
        $allowed_types['jpg']  = 'jpg';
        $allowed_types['jpeg'] = 'jpeg';
        $allowed_types['gif']  = 'gif';
        $allowed_types['png']  = 'png';

        // If not allowed type, skip
        if ( ! in_array(strtolower($type['ext']), $allowed_types) || ! $exif) {
          $wps_ic->log->write_log($attachment->ID, 'Not a valid type', '0', 'restore');
          continue;
        }

        // Set compressing
        update_post_meta($attachment->ID, 'wps_ic_in_bulk', 'true');

        // Add queue
        $queue = $wps_ic->queue->add_queue($attachment->ID, 'hidden_restore_bulk');
        $wps_ic->log->write_log($attachment->ID, 'Added to queue', '0', 'restore');

        if ($queue) {
          // Count files
          $count_files ++;
        }
      }

      // Cron Details
      update_option('wps_ic_compress_info', array('total' => $count_files, 'action' => 'Restoring'), 60 * 60 * 24);

      if ($response == 'none') {
        return;
      } else {
        if (empty($_POST['attachment_id'])) {
          $queue = $wps_ic->queue->get_hidden_restore_bulk_queue();
          wp_send_json_success($queue);
        } else {
          wp_send_json_success();
        }
      }
    }

    wp_send_json_error();
  }


  /**
   * Bulk Compress Prepare
   */
  public
  function wps_ic_compress_bulk_prep_background() {
    global $wps_ic, $wpdb;
    $settings = get_option(WPS_IC_SETTINGS);

    $output = array();

    $count_files = 0;

    delete_option(WPS_IC_STATS_BULK_FILES);
    delete_option(WPS_IC_STATS_BULK_TOTAL_FILES);
    delete_option(WPS_IC_STATS_BULK_SAVINGS);
    delete_option(WPS_IC_STATS_BULK_AVG);

    // Clear whole queue
    $wps_ic->queue->clear_queue('compress_bulk');
    $wps_ic->queue->clear_queue('hidden_compress_bulk');
    $wps_ic->queue->clear_queue('restore_bulk');
    $wps_ic->queue->clear_queue('hidden_restore_bulk');
    $wps_ic->queue->clear_queue('generate_thumbnail');

    /*
     * Check if it's a single file clicked or bulk compress button
     */
    $attachments = $wpdb->get_results("SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_type='attachment' AND post_status='inherit' ORDER BY post_date DESC");

    // Count attachments and check if user has enough credits
    $count_attachments = count($attachments);

    // Total to compress
    $required_credits = $count_attachments;

    update_option('wps_ic_reserved_credits', $count_attachments);

    $wps_ic->log->write_log('7777', 'Required Credits: ' . $required_credits . ' Total Images: ' . $count_attachments, '0', 'compress');

    // Does user have enough credits?
    $check_credits = wp_remote_get(WPS_IC_APIURL . '?apikey=' . $wps_ic::$api_key . '&check_credits=true', array('timeout' => '25', 'sslverify' => false));

    if (wp_remote_retrieve_response_code($check_credits) == 200) {
      $body = wp_remote_retrieve_body($check_credits);
      $body = json_decode($body, true);

      if ($body['success'] == 'true') {
        // OK
        $credits = $body['data']['credits'];

        if ($credits == 0) {
          // Write Log
          $wps_ic->log->write_log('7777', 'Exited bulk, not enough credits!', '0', 'compress');

          wp_send_json_error('not_enough_credits');
        }

        // User does not have enough credits
        if ($required_credits > $credits) {

          // Write Log
          $wps_ic->log->write_log('7777', 'Not enough credits (' . $credits . '), moving on until credits are exhausted!', '0', 'compress');
        }

      }
    } else {
      // Write Log
      $wps_ic->log->write_log('7777', 'API Offline', '0', 'compress');

      wp_send_json_error('api_offline');
    }

    $required_credits_per_image = 0;
    $available_credits          = $credits;
    $credits_flag               = 0;

    if ($attachments) {
      foreach ($attachments as $attachment) {

        $required_credits_per_image = 1;
        if ($available_credits < $required_credits_per_image) {
          $queue        = $wps_ic->queue->get_compress_bulk_queue();
          $credits_flag = 1;
          $wps_ic->log->write_log('7777', 'Not enough credits avail: ' . $available_credits . ' < ' . $required_credits_per_image, '0', 'compress');
          break;
        }

        $excluded = get_post_meta($attachment->ID, 'wps_ic_exclude', true);
        if ( ! empty($excluded) && $excluded == 'true') {
          $wps_ic->log->write_log('7777', 'Image ID: ' . $attachments->ID . ' is EXCLUDED!', '0', 'compress');
          continue;
        }

        $data = get_post_meta($attachment->ID, 'wps_ic_data', true);
        if ( ! empty($data) && ! empty($data['new'])) {
          $wps_ic->log->write_log('7777', 'Image ID: ' . $attachments->ID . ' is COMPRESSED!', '0', 'compress');
          continue;
        }

        if ($data == 'not_able') {
          $wps_ic->log->write_log('7777', 'Image ID: ' . $attachments->ID . ' is NOT ABLE!', '0', 'compress');
          continue;
        }

        $available_credits = $available_credits - $required_credits_per_image;

        // Allowed type
        $file_data = get_attached_file($attachment->ID);
        $type      = wp_check_filetype($file_data);
        $exif      = exif_imagetype($file_data);

        $allowed_types         = array();
        $allowed_types['jpg']  = 'jpg';
        $allowed_types['jpeg'] = 'jpeg';
        $allowed_types['gif']  = 'gif';
        $allowed_types['png']  = 'png';

        if ( ! in_array(strtolower($type['ext']), $allowed_types) || ! $exif) {
          $wps_ic->log->write_log('7777', 'Image ID: ' . $attachments->ID . ' is NOT ALLOWED TYPE!', '0', 'compress');
          continue;
        }

        // Old image data
        $compress_data['old']['size'] = filesize($file_data);
        $compress_data['old']['data'] = wp_get_attachment_metadata($attachment->ID);
        update_post_meta($attachment->ID, 'wps_ic_data', $compress_data);

        // Set compressing
        update_post_meta($attachment->ID, 'wps_ic_in_bulk', 'true');

        // Add queue
        $queue = $wps_ic->queue->add_queue($attachment->ID, 'compress_bulk');

        $count_files ++;
      }

      $wps_ic->log->write_log('7777', 'Total files counted: ' . $count_files, '0', 'compress');

      update_option(WPS_IC_STATS_BULK_TOTAL_FILES, $count_files);

      if ($credits_flag) {
        wp_send_json_success(array('queue' => $queue, 'msg' => 'not_enough_credits_notification'));
      }

      if ( ! empty($_POST['attachment_id'])) {
        $queue = $wps_ic->queue->get_compress_queue();
        wp_send_json_success(array('queue' => $queue));
      } else {
        $queue = $wps_ic->queue->get_compress_bulk_queue();

        update_option(WPS_IC_BULK_COMPRESS_QUEUE, $queue);

        wp_send_json_success(array('queue' => $queue));
      }
    }

    wp_send_json_error();
  }


  /**
   * Hidden Bulk Compress Prepare
   */
  public function wps_ic_compress_bulk_prep_hidden_background($response = 'json') {
    global $wps_ic, $wpdb;

    update_option('wps_ic_hidden_bulk_running', 'true');
    update_option('wps_ic_compess_cron', array());
    update_option('wps_ic_bulk_started', microtime(true));

    $count_files = 0;

    delete_option(WPS_IC_STATS_BULK_FILES);
    delete_option(WPS_IC_STATS_BULK_TOTAL_FILES);
    delete_option(WPS_IC_STATS_BULK_SAVINGS);
    delete_option(WPS_IC_STATS_BULK_AVG);

    // Clear whole queue
    $wps_ic->queue->clear_queue('hidden_compress_bulk');
    $wps_ic->queue->clear_queue('compress_bulk');
    $wps_ic->queue->clear_queue('restore_bulk');
    $wps_ic->queue->clear_queue('hidden_restore_bulk');
    $wps_ic->queue->clear_queue('generate_thumbnail');

    /*
     * Check if it's a single file clicked or bulk compress button
     */
    $attachments = $wpdb->get_results("SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_type='attachment' AND post_status='inherit' ORDER BY post_date DESC");

    // Count attachments and check if user has enough credits
    $count_attachments = count($attachments);

    // Total to compress
    $required_credits = 1;

    update_option('wps_ic_reserved_credits', $count_attachments);

    // Does user have enough credits?
    $check_credits = wp_remote_get(WPS_IC_APIURL . '?apikey=' . $wps_ic::$api_key . '&check_credits=true', array('timeout' => '25', 'sslverify' => false));

    if (wp_remote_retrieve_response_code($check_credits) == 200) {
      $body = wp_remote_retrieve_body($check_credits);
      $body = json_decode($body, true);

      if ($body['success'] == 'true') {
        // OK
        $credits = $body['data']['credits'];

        if ($credits == 0) {
          // Write Log
          wp_send_json_error('not_enough_credits');
        }

        // User does not have enough credits
        if ($required_credits > $credits) {
          // Write Log
        }

      }
    } else {
      wp_send_json_error('api_offline');
    }

    $available_credits = $credits;
    $credits_flag      = 0;

    if ($attachments) {
      foreach ($attachments as $attachment) {

        $required_credits_per_image = 1;
        if ($available_credits < $required_credits_per_image) {
          $queue        = $wps_ic->queue->get_compress_bulk_queue();
          $credits_flag = 1;
          break;
        }

        $excluded = get_post_meta($attachment->ID, 'wps_ic_exclude', true);
        if ( ! empty($excluded) && $excluded == 'true') {
          continue;
        }

        $data = get_post_meta($attachment->ID, 'wps_ic_data', true);
        if ( ! empty($data) && ! empty($data['new'])) {
          continue;
        }

        if ($data == 'not_able') {
          continue;
        }

        $available_credits = $available_credits - $required_credits_per_image;

        // Allowed type
        $file_data = get_attached_file($attachment->ID);
        $type      = wp_check_filetype($file_data);
        $exif      = exif_imagetype($file_data);

        $allowed_types         = array();
        $allowed_types['jpg']  = 'jpg';
        $allowed_types['jpeg'] = 'jpeg';
        $allowed_types['gif']  = 'gif';
        $allowed_types['png']  = 'png';

        if ( ! in_array(strtolower($type['ext']), $allowed_types) || ! $exif) {
          continue;
        }

        // Old image data
        $compress_data['old']['size'] = filesize($file_data);
        $compress_data['old']['data'] = wp_get_attachment_metadata($attachment->ID);
        update_post_meta($attachment->ID, 'wps_ic_data', $compress_data);

        // Set compressing
        update_post_meta($attachment->ID, 'wps_ic_in_bulk', 'true');

        // Add queue
        $queue = $wps_ic->queue->add_queue($attachment->ID, 'hidden_compress_bulk');

        $count_files ++;
      }

      // Cron Details
      update_option('wps_ic_compress_info', array('total' => $count_files, 'action' => 'Compressing'), 60 * 60 * 24);

      if ($response == 'none') {
        return;
      } else {

        if ($credits_flag) {
          wp_send_json_success(array('queue' => $queue, 'msg' => 'not_enough_credits_notification'));
        }

        if ( ! empty($_POST['attachment_id'])) {
          $queue = $wps_ic->queue->get_compress_queue();
          wp_send_json_success(array('queue' => $queue));
        } else {
          $queue = $wps_ic->queue->get_compress_bulk_queue();
          wp_send_json_success(array('queue' => $queue));
        }

      }
    }

    wp_send_json_error();
  }


  /**
   * Compress Single Image
   */
  public
  function wps_ic_compress_single() {
    global $wps_ic;

    ini_set('max_execution_time', '3600');

    if ( ! function_exists('update_option')) {
      require_once(ABSPATH . "wp-includes" . '/option.php');
    }

    /*
     * Check if it's a single file clicked or bulk compress button
     */
    $queued          = array();
    $queued_excluded = array();

    if ( ! empty($_POST['attachments'])) {
      $attachments = $_POST['attachments'];
      $attachments = (object)$attachments;

      $attachments_output = array();
      foreach ($attachments as $id => $attachment) {
        $attachment           = (int)$attachment;
        $attachments_output[] = (object)array('ID' => $attachment);
      }

      $attachments = (object)$attachments_output;

    } else {
      $attachments[] = (object)array('ID' => sanitize_text_field($_POST['attachment_id']));
      $attachments   = (object)$attachments;
    }

    if ($attachments) {
      foreach ($attachments as $attachment) {

        /**
         * Is the attachment excluded?
         */
        $excluded = get_post_meta($attachment->ID, 'wps_ic_exclude', true);
        if ( ! empty($excluded) && $excluded == 'true') {
          $queued_excluded[] = $attachment->ID;
          do_action('ic_debug', $_POST['attachment_id'], 'File Excluded');
          continue;
        }

        /**
         * Is the attachment already compressed?
         */
        $data = get_post_meta($attachment->ID, 'wps_ic_data', true);
        if ( ! empty($data) && ! empty($data['new'])) {
          $queued_excluded[] = $attachment->ID;
          do_action('ic_debug', $_POST['attachment_id'], 'File has data');
          do_action('ic_debug', $_POST['attachment_id'], $data['new']);
          continue;
        }

        // Mark attachment as compressing
        update_post_meta($attachment->ID, 'wps_ic_in_bulk', 'true');

        // Add the attachment to queue
        $wps_ic->queue->remove_queue($attachment->ID);
        $queue = $wps_ic->queue->add_queue($attachment->ID, 'hidden_compress_bulk');

        $wps_ic->compress->bulk(array('attachments' => array($attachment->ID)));
      }

      if (empty($_POST['attachment_id'])) {
        wp_send_json_success(admin_url('upload.php'));
      } else {
        wp_send_json_success(array('list' => $attachments, 'queued' => $queued, 'queue_excluded' => $queued_excluded, 'attachments' => array($attachment->ID)));
      }
    }

    wp_send_json_error();
  }


  /**
   * Compress the image
   */
  public
  function single_compress() {
    global $wps_ic, $wpdb;

    // Change memory limits
    $wps_ic->change_limits();

    // Sanitize data
    $_POST = $this->sanitize_post($_POST);

    // Get attachment ID
    $attachment_id = (int)$_POST['attachment_id'];
    $apikey        = $wps_ic->options->get_option('api_key');

    do_action('ic_debug', $_POST['attachment_id'], 'Init Compression');

    // Set compressing flags
    update_post_meta($attachment_id, 'wps_ic_compressing', 'true');
    update_post_meta($attachment_id, 'wps_ic_in_bulk', 'true');

    // Run Ajax for full image
    /*$call = wp_remote_get(site_url('?ic_compress=true&apikey=' . $apikey . '&attachment_id=' . $attachment_id . '&cache=' . time()), array('timeout' => 20, 'sslverify' => false));
    $body = wp_remote_retrieve_body($call);


    wp_send_json_success(array('url' => site_url('?ic_compress=true&apikey=' . $apikey . '&attachment_id=' . $attachment_id), 'body' => print_r($body, true)));*/

    wp_schedule_single_event(time(), 'wps_ic_compress_single', array('attachments' => array($attachment_id)));

    wp_send_json_success('event-scheduled');
  }


  /**
   * Compress the image
   */
  public
  function single_restore() {
    global $wps_ic, $wpdb;

    // Change memory limits
    $wps_ic->change_limits();

    // Sanitize data
    $_POST = $this->sanitize_post($_POST);

    // Get attachment ID
    $attachment_id = (int)$_POST['attachment_id'];
    $apikey        = $wps_ic->options->get_option('api_key');

    do_action('ic_debug', $_POST['attachment_id'], 'Init Restore');

    // Set compressing flags
    update_post_meta($attachment_id, 'wps_ic_restoring', 'true');
    update_post_meta($attachment_id, 'wps_ic_in_bulk', 'true');

    // Run Ajax for full image
    #$call = wp_remote_get(site_url('?ic_restore=true&apikey=' . $apikey . '&attachment_id=' . $attachment_id . '&cache=' . time()), array('timeout' => 20, 'sslverify' => false));
    #$body = wp_remote_retrieve_body($call);

    // TODO: RESTORE

    wp_send_json_success('event-scheduled');
  }


  /**
   * Do the actual compress
   */
  public
  function wps_ic_call_compress() {
    global $wps_ic;

    ini_set('max_execution_time', '3600');

    $attachment_id = sanitize_text_field($_GET['attachment_id']);
    $apikey        = sanitize_text_field($_GET['apikey']);

    // TODO: Add verification if api key is correct

    if ( ! empty($attachment_id)) {
      $wps_ic->compress->single_bulk_v2(array('attachment_id' => $attachment_id));
    } else {
      die('hacking?');
    }
  }


  /**
   * Do the actual restore
   */
  public
  function wps_ic_call_restore() {
    global $wps_ic;

    ini_set('max_execution_time', '120');

    $attachment_id = sanitize_text_field($_GET['attachment_id']);
    $apikey        = sanitize_text_field($_GET['apikey']);

    // TODO: Add verification if api key is correct

    if ( ! empty($attachment_id)) {
      $wps_ic->compress->hidden_restore($attachment_id);
    } else {
      die('hacking?');
    }
  }


  /**
   * Sanitizes POST variables
   *
   * @param $post
   *
   * @return mixed
   */
  public
  function sanitize_post(
    $post
  ) {
    if ($post) {

      foreach ($post as $key => $value) {
        $post[ $key ] = sanitize_text_field($value);
      }
    }

    return $post;
  }


  /**
   * Restore the file
   */
  public
  function wps_ic_restore_attachment() {
    global $wps_ic;

    // Change memory limits
    $wps_ic->change_limits();

    $attachment_ID = sanitize_text_field($_POST['attachment_id']);

    if ($attachment_ID == 0) {
      // Remove Queue
      $wps_ic->queue->remove_queue($attachment_ID, false, 'restore');
      $wps_ic->queue->remove_queue($attachment_ID, false, 'hidden_restore_bulk');
    }

    $reset = get_post_meta($attachment_ID, 'wps_ic_reset', true);
    if ($reset && $reset == 'true') {
      $wps_ic->compress->restore($attachment_ID, $_POST['hash'], 'table');
    } else {
      $wps_ic->compress->restore($attachment_ID, $_POST['hash'], 'table');
    }

    wp_send_json_success();
  }


  /**
   * Restore the image
   */
  public
  function wps_ic_restore_single_btn() {
    global $wps_ic;

    // Change memory limits
    $wps_ic->change_limits();
    $queue = get_option(WPS_IC_SINGLE_RESTORE_QUEUE);

    if (empty($_POST['type'])) {
      $type = 'restore';
    } else {
      $type = sanitize_text_field($_POST['type']);
    }

    if ($type == 'reset') {
      # Working but trying better solution
      #$wps_ic->compress->reset($_POST['attachment_id'], 'table');
    }

    /*
     * Check if it's a single file clicked or bulk compress button
     */
    $queued = array();

    $queue[ $_POST['attachment_id'] ] = $_POST['attachment_id'];
    update_option(WPS_IC_SINGLE_RESTORE_QUEUE, $queue);

    $attachments[] = (object)array('ID' => sanitize_text_field($_POST['attachment_id']));
    $attachments   = (object)$attachments;

    if ($attachments) {
      foreach ($attachments as $attachment) {

        if ($type == 'reset') {
          update_post_meta($attachment->ID, 'wps_ic_reset', 'true');
        }

        // Set compressing
        update_post_meta($attachment->ID, 'wps_ic_restoring', 'true');
        update_post_meta($attachment->ID, 'wps_ic_in_bulk', 'true');

        // Add to Queue
        $wps_ic->queue->remove_queue($attachment->ID);
        $wps_ic->queue->add_queue($attachment->ID, 'hidden_restore_bulk');
        $wps_ic->compress->bulk_restore(array('attachments' => array($attachment->ID)));

        $queued[] = $attachment->ID;
      }

      wp_send_json_success(array('list' => $attachments, 'queued' => $queued));
    }

    wp_send_json_error();
  }


  /**
   * Authorize site with remote api
   */
  public
  function wps_ic_authorize_api() {
    global $wps_ic;

    $site    = site_url();
    $api_key = $this->options->get_option('api_key');

    $call = wp_remote_get(WPS_IC_APIURL . '?authorize=true&site=' . urlencode($site) . '&api_key=' . $api_key, array('timeout' => 25, 'sslverify' => false));

    if (wp_remote_retrieve_response_code($call) == 200) {
      $body = wp_remote_retrieve_body($call);
      $body = json_decode($body);

      $wps_ic->options->set_defaults();
      $wps_ic->options->set_option('response_key', $body->data);
      $wps_ic->options->api_key('response_key', $api_key);
      wp_send_json_success();
    }

    wp_send_json_error('Oops! There has been an error in authorize api!');
  }


  /**
   * Deauthorize site with remote api
   */
  public
  function wps_ic_deauthorize_api() {
    global $wps_ic;

    // Vars
    $site   = site_url();
    $apikey = $wps_ic->options->get_option('api_key');

    // Setup URI
    $uri = WPS_IC_KEYSURL;
    $uri .= '?action=disconnect';
    $uri .= '&apikey=' . $apikey;
    $uri .= '&site=' . urlencode($site);

    // Verify API Key is our database and user has is confirmed getresponse
    $get = wp_remote_get($uri, array('timeout' => 20, 'sslverify' => false));

    #if (wp_remote_retrieve_response_code($get) == 200) {
    #$body = wp_remote_retrieve_body($get);
    #$body = json_decode($body);

    #if ($body->success == true) {
    $wps_ic->options->set_option('api_key', '');
    $wps_ic->options->set_option('response_key', '');
    $wps_ic->options->set_option('orp', '');
    //
    #wp_send_json_success();
    #}

    #wp_send_json_success();
    #}

    #wp_send_json_error('We were not able to communicate with api!');
  }

}