<?php


/**
 * Class - Upgrade
 */
class wps_ic_upgrade extends wps_ic {


  public function __construct() {
    $this->upgrade_table();
  }


  /**
   * Create the log table for old versions
   * @since 1.1.62
   */
  public function create_log_table() {
    $database = new wps_ic_database();
    $database->create_log_table();
    $database->create_compress_table();
  }


  /**
   * Update cron schedule
   * @since 1.1.66
   */
  public function upgrade_table() {
    global $wpdb, $wps_ic_blogID;

    if (!$wpdb->query("SELECT * FROM `" . $wpdb->prefix . "ic_queue`")) {
      return;
    }

    error_reporting(0);
    ini_set('display_errors', 0);

    $latest        = '4.1.0';
    $update_option = get_option('wps_ic_updated');

    if ( ! empty($_GET['force_db']) || empty($update_option) || $update_option != $latest) {

      // Create Stats Table
      $charset_collate = $wpdb->get_charset_collate();

      // Compressed Table
      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_compressed` LIKE 'blogID'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_compressed ADD `blogID` INT NOT NULL DEFAULT '0' AFTER `attachment_ID`;");
      }

      // Log Table
      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_log` LIKE 'blogID'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_log ADD `blogID` INT NOT NULL DEFAULT '0' AFTER `ID`;");
      }

      // Queue Table
      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_queue` LIKE 'blogID'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_queue ADD `blogID` INT NOT NULL DEFAULT '0' AFTER `ID`;");
      }

      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_queue` LIKE 'message'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_queue ADD `message` text COLLATE utf8mb4_unicode_ci NOT NULL AFTER `status`;");
      }

      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_queue` LIKE 'in_cron'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_queue ADD `in_cron` tinyint(4) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0' AFTER `status`;");
      }

      // Stats Table
      $queue = $wpdb->get_row("SHOW COLUMNS FROM `" . $wpdb->prefix . "ic_stats` LIKE 'blogID'");
      if ( ! $queue) {
        $wpdb->query("ALTER TABLE " . $wpdb->prefix . "ic_stats ADD `blogID` INT NOT NULL DEFAULT '0' AFTER `attachment_ID`;");
      }

      update_option('wps_ic_updated', $latest);

    }

  }

}