<?php global $wps_ic, $wpdb; ?>
<div class="wrap">
  <div class="wps_ic_wrap wps_ic_settings_page">

    <div class="wp-compress-header">
      <div class="wp-ic-logo-container">
        <div class="wp-compress-logo">
          <img src="<?php echo WPS_IC_URI; ?>assets/images/logo/blue-icon.svg"/>
          <div class="wp-ic-logo-inner">
            <h3 style="color: #333;">WP Compress <span class="small"><?php echo $wps_ic::$version; ?></span></h3>
          </div>
        </div>
      </div>
      <div class="clearfix"></div>
    </div>

    <?php

    if ( ! empty($_GET['debug_test'])) {

      if ($_GET['debug_test'] == 'verify_api_key') {
        $options = get_option(WPS_IC_OPTIONS);

        // Setup URI
        $uri = WPS_IC_KEYSURL;
        $uri .= '?action=verify_api_key';
        $uri .= '&apikey=' . $options['api_key'];
        $uri .= '&site=' . urlencode(site_url());

        $start = microtime(true);

        $get = wp_remote_get($uri, array('timeout' => 60, 'sslverify' => false));
        if (wp_remote_retrieve_response_code($get) == 200) {
          $body      = wp_remote_retrieve_body($get);
          $body_json = json_decode($body);

          if ($body_json->data->code == 'ok') {
            set_transient('ic_debug_verify_api_key', 'OK', 60);
          } else {
            set_transient('ic_debug_verify_api_key', 'Failed', 60);
          }
        }

        $end = microtime(true);
        ?>
        <table class="form-table">
          <tbody>
          <tr>
            <th>API Url:</th>
            <td><?php echo $uri; ?></td>
          </tr>
          <tr>
            <th>Response Code (200 is OK):</th>
            <td><?php echo wp_remote_retrieve_response_code($get); ?></td>
          </tr>
          <tr>
            <th>
              Response Body
            </th>
            <td>
              <?php echo $body; ?>
            </td>
          </tr>
          <tr>
            <th>
              <a href="<?php echo $uri; ?>" target="_blank" class="button-primary">Try Manually</a>
              <a href="<?php echo admin_url('admin.php?page=wpcompress&debug=true'); ?>" class="button-primary">Return Back</a>
            </th>
          </tr>
          </tbody>
        </table>
        <?php

        die();
      }

      if ($_GET['debug_test'] == 'test_compress') {
        $options = get_option(WPS_IC_OPTIONS);

        // Remove on upload
        $old_settings = $options;
        delete_option(WPS_IC_SETTINGS);

        $test_image_upload = 'Failed';
        require_once(ABSPATH . 'wp-admin/includes/media.php');
        require_once(ABSPATH . 'wp-admin/includes/file.php');
        require_once(ABSPATH . 'wp-admin/includes/image.php');

        // Test Image
        $image = 'https://plugin.wpcompress.xyz/test-image.jpg';

        // Was it already uploaded?
        $test_image = get_option('wps_ic_test_image');

        if (!empty($test_image)) {
          delete_option('wps_ic_test_image');
          wp_delete_attachment($test_image, true);
          $test_image = false;
        }

        if (empty($test_image) || !$test_image) {
          $download_start = microtime(true);
          $media = media_sideload_image($image, 0, '', 'id');
          update_option('wps_ic_test_image', $media);
          $test_image_upload = 'OK';
          $download_end = microtime(true);
        }

        update_option(WPS_IC_SETTINGS, $old_settings);

        $start = microtime(true);

        $compress_test = get_option('wps_ic_test_image');
        $wps_ic->compress->single_bulk_v2(array('attachment_id' => $compress_test, 'apikey' => $options['api_key'], 'test' => true));

        $data = get_post_meta($compress_test, 'wps_ic_data', true);

        $end = microtime(true);

        if ( ! empty($data)) {
          // Compressed
          $compress_test_txt = 'OK in ' . ($end-$start) . ' seconds';
        } else {
          $compress_test_txt = 'Failed in ' . ($end-$start) . ' seconds';
          wp_delete_attachment($compress_test);
          delete_option('wps_ic_test_image');
        }
        ?>
        <table class="form-table">
          <tbody>
          <tr>
            <th>Test Image Upload:</th>
            <td><?php
              echo $test_image_upload;
              ?><br/>
              <?php
              echo 'Download took: ' . ($download_end-$download_start) . ' seconds';
              ?></td>
          </tr>
          <tr>
            <th>Test Image Data:</th>
            <td><?php
              $image = wp_get_attachment_image_src($media, 'full');
              echo '<img src="' . $image[0] . '" style="width:320px;"/>';
              ?></td>
          </tr>
          <tr>
            <th>Test Image Compress:</th>
            <td><?php echo $compress_test_txt; ?></td>
          </tr>
          <tr>
            <th>Compress Data:</th>
            <td><?php echo print_r($data, true); ?></td>
          </tr>
          <tr>
            <th>
              <a href="<?php echo admin_url('admin.php?page=wpcompress&debug=true'); ?>" class="button-primary">Return Back</a>
            </th>
          </tr>
          </tbody>
        </table>
        <?php

        die();
      }

      if ($_GET['debug_test'] == 'view_queue') {
        ?>
    <table class="wp-list-table widefat fixed striped posts">
      <thead>
      <tr>
        <th>Attachment ID</th>
        <th>Type</th>
        <th>Message</th>
        <th>Action</th>
      </tr>
      </thead>
      <tbody>
      <?php
      $queue = $wpdb->get_var("SELECT * FROM " . $wpdb->prefix . "ic_queue");
      if ($queue) {
      foreach ($queue as $item) {
      ?>
      <tr>
        <td><?php echo $item->attachment_ID; ?></td>
        <td><?php echo $item->type; ?></td>
        <td><?php echo $item->message; ?></td>
        <td></td>
      </tr>
      <?php }
        } ?>

      </tbody>
    </table>
        <?php
      }

    } else {

    ?>


    <table class="wp-list-table widefat fixed striped posts">
      <thead>
      <tr>
        <th>Check Name</th>
        <th>Value</th>
        <th>Status</th>
        <th>Action</th>
      </tr>
      </thead>
      <tbody>
      <tr>
        <td>API Key</td>
        <td>
          <?php
          $options = get_option(WPS_IC_OPTIONS);
          echo $options['api_key'];
          ?>
        </td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td>Plugin Activated</td>
        <td><?php
          if (is_plugin_active('wp-compress-image-optimizer/wp-compress.php')) {
            echo 'Yes';
            $status = 'OK';
          } else {
            echo 'No';
            $status = 'BAD';
          }
          ?></td>
        <td><?php echo $status; ?></td>
        <td>None</td>
      </tr>
      <tr>
        <td>PHP Version</td>
        <td>
          <?php
          $version = phpversion();
          echo $version;
          if (version_compare($version, '7.0', '>=')) {
            $status = 'OK';
          } else {
            $status = 'BAD';
          }
          ?>
        </td>
        <td><?php echo $status; ?></td>
        <td>None</td>
      </tr>
      <tr>
        <td>WP Version</td>
        <td>
          <?php
          $wp_version = get_bloginfo('version');
          echo $wp_version;
          if (version_compare($wp_version, '5.0', '>=')) {
            $status = 'OK';
          } else {
            $status = 'BAD';
          }
          ?>
        </td>
        <td>
          <?php
          echo $status;
          ?>
        </td>
        <td>
          None
        </td>
      </tr>
      <tr>
        <td>Number of Images in Media Library</td>
        <td>
          <?php
          $attachments = $wpdb->get_var("SELECT COUNT(ID) FROM " . $wpdb->posts . " WHERE post_type='attachment' AND post_status='inherit'");
          echo $attachments;
          ?>
        </td>
        <td>-</td>
        <td>None</td>
      </tr>
      <tr>
        <td>Number of <strong>compressed</strong> Images in Media Library</td>
        <td>
          <?php
          $attachments = $wpdb->get_var("SELECT COUNT(posts.ID) FROM " . $wpdb->posts . " AS posts 
          INNER JOIN " . $wpdb->postmeta . " AS pm ON pm.post_id=posts.ID
          WHERE posts.post_type='attachment' AND posts.post_status='inherit' AND pm.meta_key='wps_ic_compressed' AND pm.meta_value='true'");
          echo $attachments;
          ?>
        </td>
        <td>-</td>
        <td>None</td>
      </tr>
      <tr>
        <td>Number of Thumbnails per image</td>
        <td>
          <?php
          $thumbs = get_intermediate_image_sizes();
          echo count($thumbs);
          ?>
        </td>
        <td>-</td>
        <td>None</td>
      </tr>
      <tr>
        <td>Number of Thumbnails generated</td>
        <td>
          <?php
          $thumbs = get_intermediate_image_sizes();
          echo $attachments * count($thumbs);
          ?>
        </td>
        <td>-</td>
        <td>None</td>
      </tr>
      <tr>
        <td>Images <strong style="color: #ff3019;">Missing</strong> from CDN</td>
        <td>
          <?php
          $attachments = get_posts(array(
                                     'post_type'      => 'attachment',
                                     'posts_per_page' => '-1',
                                     'meta_query'     => array(
                                       array(
                                         'key'     => 'wps_ic_cdn',
                                         'compare' => 'NOT EXISTS',
                                       )
                                     )
                                   ));
          $missing     = count($attachments);
          if ($missing > 0) {
            $status = '<span style="color: #ff3019;">BAD</span>';
          } else {
            $status = '<span style="color: #000;">OK</span>';
          }
          echo $missing;
          ?>
        </td>
        <td>
          <?php echo $status; ?>
        </td>
        <td>
          <?php
          if ($missing > 0) {
            echo '<a href="#">Rebuild</a>';
          } else {
            echo '-';
          }
          ?>
        </td>
      </tr>
      <tr>
        <td>Cron</td>
        <td>
          <?php
          $cron_Status = 'Enabled';
          if (defined('DISABLE_WP_CRON')) {
            $cron_Status = 'Disabled';
          }
          echo $cron_Status;
          ?>
        </td>
        <td>
          <?php
          if ($cron_Status == 'Disabled') {
            $status = '<span style="color: #ff3019;">BAD</span>';
          } else {
            $status = '<span style="color: #000;">OK</span>';
          }
          echo $status;
          ?>
        </td>
        <td>-</td>
      </tr>
      <tr>
        <td>Verify API Key</td>
        <td>Can we communicate with API endpoint?</td>
        <td>
          <?php
          $verify_api_key = get_transient('ic_debug_verify_api_key');
          if ( ! $verify_api_key) {
            echo 'Not tested';
          } else {
            echo $verify_api_key;
          }
          ?>
        </td>
        <td>
          <a href="<?php echo admin_url('admin.php?page=wpcompress&debug=true&debug_test=verify_api_key'); ?>" class="button button-primary">Test</a>
        </td>
      </tr>
      <tr>
        <td>Test Compress</td>
        <td>Can we communicate with Compress API endpoint?</td>
        <td>
          <?php
          $test_compress = get_transient('ic_debug_test_compress');
          if ( ! $test_compress) {
            echo 'Not tested';
          } else {
            echo $test_compress;
          }
          ?>
        </td>
        <td>
          <a href="<?php echo admin_url('admin.php?page=wpcompress&debug=true&debug_test=test_compress'); ?>" class="button button-primary">Test</a>
        </td>
      </tr>
      <tr>
        <td>Queue Database Table</td>
        <td>Is there anything left in database Queue table waiting for compress or restore?</td>
        <td>
          <?php
          global $wpdb;
          $queue = $wpdb->get_var("SELECT COUNT(ID) FROM " . $wpdb->prefix . "ic_queue WHERE status='0'");
          if (!$queue || $queue == 0) {
            echo 'OK';
          } else {
            echo 'There are ' . $queue . ' images queued.';
          }
          ?>
        </td>
        <td>
          <a href="<?php echo admin_url('admin.php?page=wpcompress&debug=true&debug_test=view_queue'); ?>">View Queue</a>
        </td>
      </tr>
      </tbody>
    </table>

    <?php } ?>

  </div>


</div>